![HEADER2](https://github.com/actionschnitzel/tingsandstuff/blob/main/pigro_24_gihub.png?raw=true)
---

# :bento: All Settings In One Place!
### PiGro - Just Click it! brings the normal desktop functionalities back to Pixel!

- Independently developed app store for APT, Flatpak and Pi apps
- Quick access to system functions
- Overclocking for Raspberry Pi 4 & 5

 :heavy_check_mark: System Monitoring :heavy_check_mark: System Configuration :heavy_check_mark: Autostarts :heavy_check_mark: Process Monitor & Killer
 :heavy_check_mark: Update & Upgrade GUI :heavy_check_mark:Multi Install GUI :heavy_check_mark: Change & Customize DE :heavy_check_mark: Overclocking
 :heavy_check_mark: Link Collection




PiGro - Just Click it! is an all-inclusive graphical user interface (GUI) software that streamlines the process of managing all your Raspberry Pi settings from one convenient location. With PiGro, you can easily keep your software up-to-date, oversee the APT installer, Pi-Apps App Store, and Flatpak, configure autostarts, overclock your Pi, monitor the system's performance, back up your applications, install desktop environments, and customize your OS theme.

Designed with user-friendliness in mind, PiGro is easily accessible to users of all levels of expertise. Its intuitive interface and straightforward controls make it effortless to access and modify any settings you require.

---


# :floppy_disk: Installation

[![badge](https://github.com/Botspot/pi-apps/blob/master/icons/badge-light.png?raw=true)](https://github.com/Botspot/pi-apps)    

## or:

### Via APT:

[Latest Debian Package](https://github.com/actionschnitzel/PiGro-Aid-/releases) download

If you have already installed Pigro via the script, remove: `~/-PiGro-Aid-` and `~/.local/Share/Applications/Pigro.Desktop`. Then Install the Debian Package.




### Supported Systems:
#### Raspberry Pi 4 & 5 <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Raspberry_Pi_Logo.svg" height="14">:
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Raspberry_Pi_Logo.svg" height="14"> [**Raspberry Pi OS**](https://www.raspberrypi.com/software/operating-systems/) (Bullseye/Bookworm): <span style="color:var(--success-dark);">fully supported</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/UbuntuCoF.svg" height="14"> [**Ubuntu**](https://ubuntu.com/download/raspberry-pi): <span style="color:var(--success-dark);">fully supported</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Ubuntu_MATE_rondel_logo.svg" height="14"> [**Ubuntu MATE**](https://ubuntu-mate.org/download/): <span style="color:var(--warn-dark);">fully supported</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/tingsandstuff/f903f9ce59da1419b02664fd416e546cb66e7793/rhino.svg" height="14"> [**Rhino Linux**](https://rhinolinux.org/): <span style="color:var(--warn-dark);">fully supported (Scroll to Important)(Ricing via xfce-setting)</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/MX_Linux_logo.svg" height="14"> [**MX Linux**](https://mxlinux.org/): <span style="color:var(--warn-dark);">fully supported</span>

#### Desktops:
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Xfce_logo.svg" height="14"> [**XFCE4**]: <span style="color:var(--warn-dark);">fully supported</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Gnomelogo.svg" height="14"> [**Gnome**]: <span style="color:var(--warn-dark);">fully supported</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Mate-logo.svg" height="14"> [**Mate**]: <span style="color:var(--warn-dark);">fully supported</span>
- <img src="https://raw.githubusercontent.com/actionschnitzel/PiGro-Aid-/data/Distros/Raspberry_Pi_Logo.svg" height="14"> [**pi-lxde-wayland**]: <span style="color:var(--warn-dark);">no ricing</span>

#### :exclamation: Installation Process & Updates

- If you have installed PiGro via Pi-Apps, you will automatically receive an update notification.
- If you have installed PiGro via Package you can check for updates in the About TAB.

---

# :exclamation: Important
### Raspberry Pi OS
#### PiGro uses `xterm` as an embedded terminal. Raspberry Pi OS sets every newly installed terminal as default. You can change that by:

Open the Terminal and type `sudo update-alternatives --config x-terminal-emulator`. All available terminal emulators are listed. `lxterminal` is the the PiOS default.

Or in PiGro: `System` > `update-alternatives` > `x-terminal-emulator`

### Rhino Linux    
The file `/home/rhino/.config/autostarts/rhino-setup.desktop` makes PiGro crash. This file is empty. To use PiGro it must be deleted.

### Xfce4
Ricing of Xfce is not jet implemented. Please use `xfce-settings`
     

---

# :hamburger: Latest Changes

[Changelog](https://github.com/actionschnitzel/PiGro-Aid-/wiki/Change-Log)    
    
---

# :doughnut: Showcase

![GUI](https://github.com/actionschnitzel/tingsandstuff/blob/main/24_showcase.png?raw=true)

---

### :two_hearts: You want support me?

PiGro is completely free. I put up to three hours into improvements and updates every day. Not to forget the countless hours I spend reading manuals and reference books. If you like my work, you can support me

[![badge](https://github.com/actionschnitzel/tingsandstuff/blob/main/PayPal_donation.png?raw=true)](https://www.paypal.com/paypalme/actionschnitzel)