#!/usr/bin/python3

import os
from os import popen
import os.path
import distro


# Get User Name
user = os.environ["USER"]

print(
    f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mHi,{user} waz uuuuup?!\033[0;0m"
)

current_version = "24.01"

print(
    f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mYou are using PiGro {current_version}\033[0;0m"
)


# Get Home Path
home = os.environ["HOME"]

print(
    f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208m{home} is your home directory!\033[0;0m"
)

# set the directory autostart path
autostart_dir_path = f"{home}/.config/autostart/"

# check if the directory exists
if not os.path.exists(autostart_dir_path):
    # create the directory if it doesn't exist
    os.makedirs(autostart_dir_path)

    print(
        f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208m{autostart_dir_path} created successfully\033[0;0m"
    )

else:
    print(
        f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208m{autostart_dir_path} already exists\033[0;0m"
    )

# Gets path to PiGro
if not os.path.exists(f"/home/{user}/PiGro-Aid-"):
    Application_path = "/opt/PiGro-Aid-"
else:
    # Application_path = str(os.getcwd())
    Application_path = f"/home/{user}/PiGro-Aid-"

print(
    f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mPiGro directory is {Application_path}\033[0;0m"
)
# Define paths to create
pigro_config_dir = f"{home}/.pigro"
pigro_config_file = f"{pigro_config_dir}/pigro.conf"

# Check if pigro directory exists
if not os.path.exists(pigro_config_dir):
    # Create pigro directory
    os.mkdir(pigro_config_dir)

    # Create pigro.conf file
    with open(pigro_config_file, "w") as f:
        f.write("[PiGro - Just Click It! Configs]\n\n")


# Check if Application_path is equal to f"{home}/PiGro-Aid-"
if Application_path == f"{home}/PiGro-Aid-":
    # Define path to scripts directory
    scripts_path = f"{Application_path}/scripts/"

    # Loop through all files in the scripts directory
    for filename in os.listdir(scripts_path):
        # Check if file extension is .sh
        if filename.endswith(".sh"):
            # Make file executable
            filepath = os.path.join(scripts_path, filename)
            os.chmod(filepath, 0o755)


# get Distro name
distro_get = distro.id()


# Gets nice Distro name
nice_name = popen("egrep '^(PRETTY_NAME)=' /etc/os-release")
nice_name = nice_name.read()
print(
    f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mYour Distro is: {nice_name[13:-2]}\033[0;0m"
)

# Get Achitecture Of OS
arch_bash = """#determine if host system is 64 bit arm64 or 32 bit armhf
if [ "$(od -An -t x1 -j 4 -N 1 "$(readlink -f /sbin/init)")" = ' 02' ];then
arch=64
printf "arm64"
elif [ "$(od -An -t x1 -j 4 -N 1 "$(readlink -f /sbin/init)")" = ' 01' ];then
arch=32
printf "armhf"
else
error "Failed to detect OS CPU architecture! Something is very wrong."
fi"""

# #global os_arch_output
os_arch = popen(arch_bash)
os_arch_output = os_arch.read()

# print(f"[Info]: Distro Architecture: {os_arch_output}")
print(
    f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mDistro Architecture: {os_arch_output}\033[0;0m"
)

# Location of config.txt
if os.path.exists("/boot/config.txt"):
    config_path = "/boot/config.txt"
elif os.path.exists("/boot/firmware/usercfg.txt"):
    config_path = "/boot/firmware/usercfg.txt"
elif os.path.exists("/boot/firmware/config.txt"):
    config_path = "/boot/firmware/config.txt"
else:
    print(
        f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mCan't find config.txt\033[0;0m"
    )
    config_path = f"{home}/config.txt"  # DEV DUMMY


get_de = os.environ["DESKTOP_SESSION"].lower()


def get_desktop_environment():
    desktop_session = os.environ.get("XDG_CURRENT_DESKTOP")
    if desktop_session == "xfce":
        return desktop_session.lower()
    elif os.environ["DESKTOP_SESSION"].lower() == "lxde-pi-wayfire":
        return "lxde-pi-wayfire"
    elif "KDE_SESSION_VERSION" in os.environ:
        return "kde"
    elif "GNOME_DESKTOP_SESSION_ID" in os.environ:
        return "gnome"
    elif "MATE_DESKTOP_SESSION_ID" in os.environ:
        return "mate"
    elif "XDG_CURRENT_DESKTOP" in os.environ:
        return os.environ["XDG_CURRENT_DESKTOP"].lower()
    else:
        return "unknown"


def get_theme():
    desktop_environment = get_desktop_environment()

    if desktop_environment == "gnome":
        theme = (
            os.popen("gsettings get org.gnome.desktop.interface gtk-theme")
            .read()
            .strip()
        )
    elif desktop_environment == "pixel-wayfire":
        theme = (
            os.popen("gsettings get org.gnome.desktop.interface gtk-theme")
            .read()
            .strip()
        )
    elif desktop_environment == "kde":
        theme = (
            os.popen(
                "kreadconfig5 --file kdeglobals --group General --key 'widgetStyle'"
            )
            .read()
            .strip()
        )
    elif desktop_environment == "xfce":
        theme = os.popen("xfconf-query -c xsettings -p /Net/ThemeName").read().strip()
    else:
        theme = "Not supported for this desktop environment"

    return theme


if "dark" in get_theme().lower():
    print(f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mDark Theme\033[0;0m")
    maincolor = "#2c2c2c"
    nav_color = "#272727"
    frame_color = "#2c2c2c"
    main_font = "white"
    info_color = "yellow"
    ext_btn = "#007acc"
    label_frame_color = "#cf274e"
else:
    print(f"\033[48;5;236m\033[38;5;231m[Info] \033[38;5;208mLight Theme\033[0;0m")
    maincolor = "#f5f5f5"
    nav_color = "#e8e8e8"
    frame_color = "#f5f5f5"
    main_font = "#454545"
    info_color = "#0075b7"
    ext_btn = "#87919b"  # "#484848"  # "#3790cc"
    label_frame_color = "#454545"


# Font Definition Vars
font_20 = ("Sans", 20)
font_16_b = ("Sans", 16, "bold")
font_16 = ("Sans", 16)
font_14 = ("Sans", 14)
font_12_b = ("Sans", 12, "bold")
font_12 = ("Sans", 12)
font_10 = ("Sans", 11)
font_10_b = ("Sans", 10, "bold")
font_9_b = ("Sans", 9, "bold")
font_9 = ("Sans", 9)
font_8_b = ("Sans", 8, "bold")
font_8 = ("Sans", 8)
