import os
import subprocess


# Check if '/bin/snap' exists
def is_snap_installed():
    return os.path.exists("/bin/snap")


# Count all installed packages using 'snap list'
def count_installed_snap_packages():
    try:
        output = subprocess.check_output(["snap", "list"]).decode("utf-8")
        packages = output.strip().split("\n")[1:]  # Skip the header line
        return len(packages)
    except subprocess.CalledProcessError:
        return -1


if is_snap_installed():
    snap_package_count = count_installed_snap_packages()
    if snap_package_count != -1:
        print(
            f"Snap is installed, and there are {snap_package_count} packages installed."
        )
    else:
        print("Failed to list installed packages using Snap.")
        snap_package_count = "-"
else:
    print("Snap is not installed on your system.")
    snap_package_count = "-"
