import os
from os import popen
import os.path
from tkinter import *
from tkinter import ttk
import tkinter as tk
from tkinter import filedialog
from PIL import ImageTk, Image
from resorcess import *
from apt_manage import *
import subprocess
from flatpak_alias_list import *
from tabs.pop_ups import *
from tabs.system_tab_check import *
import json


class LookTab(ttk.Frame):
    def __init__(self, master):
        super().__init__(master)
        self.grid(row=0, column=0, sticky="nsew")

        self.bash_history_icon = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/bash.png"
        )
        self.fm_godmode_icon = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/folder-yellow.png"
        )
        self.ico_m = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/applications-interfacedesign.png"
        )
        self.bp03 = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/bash.png"
        )
        self.ico_m2 = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/applications-webapps.png"
        )
        self.ip01 = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/download_ico.png"
        )

        self.bluetooth = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/blueman.png"
        )
        self.wifi = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/kali-wireless-attacks-trans.png"
        )

        self.pixel_set = LabelFrame(
            self,
            text="Theme Your Desktop [Gnome | Mate | XFCE]",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            highlightthickness=0,
            highlightcolor="white",
            relief=GROOVE,
            pady=10,
            padx=0,
            # width=300,
        )
        self.pixel_set.pack(pady=20, padx=40, fill="x", anchor="n")
        self.pixel_set["background"] = frame_color
        self.pixel_set.columnconfigure(0, weight=1)
        self.pixel_set.rowconfigure(0, weight=1)

        def done_message_0():
            d_mass = Done_(self)
            d_mass.grab_set()

        def why_message_0():
            y_mass = Look_Disabled(self)
            y_mass.grab_set()

        def update_theme_combobox():
            try:
                themes = [
                    d
                    for d in os.listdir("/usr/share/themes")
                    if os.path.isdir(os.path.join("/usr/share/themes", d))
                ]
                theme_combobox["values"] = themes
                theme_combobox.set("Select Theme")
            except Exception as e:
                theme_combobox.set("Error: " + str(e))

            try:
                icons = [
                    d
                    for d in os.listdir("/usr/share/icons")
                    if os.path.isdir(os.path.join("/usr/share/icons", d))
                ]
                icon_combobox["values"] = icons
                icon_combobox.set("Select Icons")
            except Exception as e:
                icon_combobox.set("Error: " + str(e))

            try:
                icons = [
                    d
                    for d in os.listdir("/usr/share/icons")
                    if os.path.isdir(os.path.join("/usr/share/icons", d))
                ]

                # Separate cursor themes from regular icon themes
                cursor_themes = [
                    icon
                    for icon in icons
                    if "cursors" in os.listdir(os.path.join("/usr/share/icons", icon))
                ]

                cursor_combobox["values"] = cursor_themes
                cursor_combobox.set("Select Cursor")
            except Exception as e:
                cursor_combobox.set("Error: " + str(e))

        def set_theme():
            selected_theme = theme_combobox.get()

            if selected_theme != "Press Refresh":
                if get_desktop_environment() == "xfce":
                    subprocess.run(
                        [
                            "xfconf-query",
                            "-c",
                            "xsettings",
                            "-p",
                            "/Net/ThemeName",
                            "-s",
                            selected_theme,
                        ]
                    )
                if get_desktop_environment() == "mate":
                    subprocess.run(
                        [
                            "gsettings",
                            "set",
                            "org.mate.interface",
                            "gtk-theme",
                            selected_theme,
                        ]
                    )
                else:
                    subprocess.run(
                        [
                            "gsettings",
                            "set",
                            "org.gnome.desktop.interface",
                            "gtk-theme",
                            selected_theme,
                        ]
                    )
                    subprocess.run(
                        [
                            "gsettings",
                            "set",
                            "org.gnome.desktop.wm.preferences",
                            "theme",
                            selected_theme,
                        ]
                    )
                done_message_0()
            # MATE#gsettings set org.mate.interface gtk-theme

        def set_icon():
            selected_icon = icon_combobox.get()

            if selected_icon != "Press Refresh":
                if get_desktop_environment() == "xfce":
                    subprocess.run(
                        [
                            "xfconf-query",
                            "-c",
                            "xsettings",
                            "-p",
                            "/Net/IconThemeName",
                            "-s",
                            selected_icon,
                        ]
                    )
                else:
                    subprocess.run(
                        [
                            "gsettings",
                            "set",
                            "org.gnome.desktop.interface",
                            "icon-theme",
                            selected_icon,
                        ]
                    )
            done_message_0()

        def set_cursor():
            selected_cursor = cursor_combobox.get()

            if selected_cursor != "Press Refresh":
                if get_desktop_environment() == "xfce":
                    subprocess.run(
                        [
                            "xfconf-query",
                            "-c",
                            "xsettings",
                            "-p",
                            "/Gtk/CursorThemeName",
                            "-s",
                            selected_cursor,
                        ]
                    )
                else:
                    subprocess.run(
                        [
                            "gsettings",
                            "set",
                            "org.gnome.desktop.interface",
                            "cursor-theme",
                            selected_cursor,
                        ]
                    )
            done_message_0()

        def open_theme_folder():
            if check_pcmanfm() == True:
                popen("sudo pcmanfm /usr/share/themes")
            else:
                popen(
                    f"pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY xdg-open /usr/share/themes"
                )

        def open_icon_folder():
            if check_pcmanfm() == True:
                popen("sudo pcmanfm /usr/share/themes")
            else:
                popen(
                    f"pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY xdg-open /usr/share/icons"
                )

        def open_lxappearance():
            popen("lxappearance")

        def y_dis():
            massage = """Raspberry Pi OS Bookworm is a mess ... a Frankenstein. Trying to change the theme or icons will break the window manager and desktop environment. One day it may work again. Until they do, the theme options in Pigro will remain disabled."""

            popen(f"x-terminal-emulator -e 'bash -c \"echo {massage}; exec bash\"'")

        theme_combobox = ttk.Combobox(self.pixel_set)
        theme_combobox.grid(
            row=1, column=0, columnspan=2, padx=10, pady=5, sticky="ewsn"
        )
        theme_combobox.set("Press Refresh")

        icon_combobox = ttk.Combobox(self.pixel_set)
        icon_combobox.grid(
            row=2, column=0, columnspan=2, padx=10, pady=5, sticky="ewsn"
        )
        icon_combobox.set("Press Refresh")

        cursor_combobox = ttk.Combobox(self.pixel_set)
        cursor_combobox.grid(
            row=3, column=0, columnspan=2, padx=10, pady=5, sticky="ewsn"
        )
        cursor_combobox.set("Press Refresh")

        # Create buttons to apply the selected settings
        theme_button = tk.Button(
            self.pixel_set,
            text="Set Theme",
            command=set_theme,
            borderwidth=0,
            background="#F2799B",
            foreground="white",
        )
        theme_button.grid(row=1, column=3, padx=10, pady=5, sticky="ew")

        icon_button = tk.Button(
            self.pixel_set,
            text="Set Icon",
            command=set_icon,
            borderwidth=0,
            background="#FCB55C",
            foreground="white",
        )
        icon_button.grid(row=2, column=3, padx=10, pady=5, sticky="ew")

        cursor_button = tk.Button(
            self.pixel_set,
            text="Set Cursor",
            command=set_cursor,
            borderwidth=0,
            background="#86C548",
            foreground="white",
        )
        cursor_button.grid(row=3, column=3, padx=10, pady=5, sticky="ew")

        theme_refresh_button = tk.Button(
            self.pixel_set,
            text="Refresh",
            command=update_theme_combobox,
            borderwidth=0,
            background=ext_btn,
            foreground="white",
        )
        theme_refresh_button.grid(
            row=4, column=0, columnspan=3, padx=10, pady=5, sticky="ew"
        )

        theme_legacy_button = tk.Button(
            self.pixel_set,
            text="Legacy Theme Bullseye",
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            command=open_lxappearance,
            state=DISABLED,
        )
        theme_legacy_button.grid(row=4, column=3, padx=10, pady=5, sticky="ew")

        theme_folder_button = tk.Button(
            self.pixel_set,
            text="Theme Folder",
            borderwidth=0,
            background="#F2799B",
            foreground="white",
            command=open_theme_folder,
        )
        theme_folder_button.grid(row=1, column=4, padx=10, pady=5, sticky="ew")

        icon_folder_button = tk.Button(
            self.pixel_set,
            text="Icon Folder",
            borderwidth=0,
            background="#FCB55C",
            foreground="white",
            command=open_icon_folder,
        )
        icon_folder_button.grid(row=2, column=4, padx=10, pady=5, sticky="ew")

        cursor_folder_button = tk.Button(
            self.pixel_set,
            text="Cursor Folder",
            borderwidth=0,
            background="#86C548",
            foreground="white",
            command=open_icon_folder,
        )
        cursor_folder_button.grid(row=3, column=4, padx=10, pady=5, sticky="ew")

        wp_folder_button = tk.Button(
            self.pixel_set,
            text="Set Wallpaper Folder",
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            command=self.select_wallpaper_directory,
        )
        wp_folder_button.grid(row=4, column=4, padx=10, pady=5, sticky="ew")

        info_button = tk.Button(
            self.pixel_set,
            text="Why is everthing DISABLED?",
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            command=why_message_0,
        )

        def install_papirus():
            # Add the functionality to be executed when the "Install Papirus + Folders" button is clicked
            print("Installing Papirus + Folders...")
            popen(
                "x-terminal-emulator -e 'bash -c \"wget -qO- https://git.io/papirus-icon-theme-install | sh && wget -qO- https://git.io/papirus-folders-install | sh; exec bash\"'"
            )

        def set_icon_theme():
            # Add the functionality to be executed when the "Set" button is clicked
            selected_theme = self.papirus_theme_combobox.get()
            selected_ver = self.papirus_version_combobox.get()
            if selected_theme != "Select a Color":
                print(f"Setting icon theme to: {selected_theme}")
                popen(
                    f"pkexec papirus-folders -C {selected_theme} --theme {selected_ver}"
                )
                if get_desktop_environment() == "xfce":
                    subprocess.run(
                        [
                            "xfconf-query",
                            "-c",
                            "xsettings",
                            "-p",
                            "/Net/IconThemeName",
                            "-s",
                            selected_ver,
                        ]
                    )
                else:
                    subprocess.run(
                        [
                            "gsettings",
                            "set",
                            "org.gnome.desktop.interface",
                            "icon-theme",
                            selected_ver,
                        ]
                    )
            else:
                print("Please select a valid icon theme.")
            done_message_0()

        # Create a LabelFrame called "Papirus Icons" and pack it
        self.papirus_icons_frame = LabelFrame(
            self,
            text="Papirus Icons",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            highlightthickness=0,
            highlightcolor="white",
            relief=GROOVE,
            pady=10,
            padx=0,
            background=maincolor,
        )
        self.papirus_icons_frame.pack(pady=20, padx=40, fill="x", anchor="n")

        # Add a button with the text "Install Papirus + Folders"
        self.install_button = Button(
            self.papirus_icons_frame,
            text="Install Papirus + Folders",
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            command=install_papirus,
        )
        self.install_button.grid(
            row=1, column=0, columnspan=4, padx=10, pady=10, sticky="we"
        )

        # Add a combobox and a button with the text "Set" in the next row
        self.icon_themes = [
            "adwaita",
            "black",
            "blue",
            "bluegrey",
            "breeze",
            "brown",
            "carmine",
            "cyan",
            "darkcyan",
            "deeporange",
            "green",
            "grey",
            "indigo",
            "magenta",
            "nordic",
            "orange",
            "palebrown",
            "paleorange",
            "pink",
            "red",
            "teal",
            "violet",
            "white",
            "yaru",
            "yellow",
        ]
        self.papirus_theme_combobox = ttk.Combobox(
            self.papirus_icons_frame, values=self.icon_themes
        )
        self.papirus_theme_combobox.grid(
            row=2, column=0, columnspan=2, padx=10, pady=10, sticky="wns"
        )
        self.papirus_theme_combobox.set("Select a Color")  # Set the default value

        self.icon_papirus_version = [
            "ePapirus",
            "Papirus",
            "Papirus-Dark",
            "Papirus-Light",
        ]
        self.papirus_version_combobox = ttk.Combobox(
            self.papirus_icons_frame, values=self.icon_papirus_version
        )
        self.papirus_version_combobox.grid(
            row=2, column=2, columnspan=2, padx=10, pady=10, sticky="wns"
        )
        self.papirus_version_combobox.set("Select a Version")  # Set the default value

        self.set_button = Button(
            self.papirus_icons_frame,
            text="Set",
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            command=set_icon_theme,
        )
        self.set_button.grid(row=2, column=4, padx=10, pady=10)

        def xfce_theme_():
            pass

        if get_desktop_environment() not in ["xfce", "gnome", "mate"]:
            # Blockieren Sie die Buttons, wenn die Desktop-Umgebung nicht übereinstimmt
            theme_button.config(state=tk.DISABLED)
            icon_button.config(state=tk.DISABLED)
            cursor_button.config(state=tk.DISABLED)
            theme_refresh_button.config(state=tk.DISABLED)
            theme_combobox.config(state=tk.DISABLED)
            icon_combobox.config(state=tk.DISABLED)
            cursor_combobox.config(state=tk.DISABLED)
            self.papirus_theme_combobox.config(state=tk.DISABLED)
            self.papirus_version_combobox.config(state=tk.DISABLED)
            self.set_button.config(state=tk.DISABLED)
            self.install_button.config(state=tk.DISABLED)
            info_button.grid(row=5, column=4, padx=10, pady=5, sticky="ew")

        if (
            get_desktop_environment() == "lxde-pi"
            or get_desktop_environment() == "lxde"
        ):
            # Setzen Sie den Zustand des speziellen Buttons für lxde-pi auf NORMAL
            theme_legacy_button.config(state=tk.NORMAL)
            # Setzen Sie den Zustand der speziellen Elemente für lxde-pi auf NORMAL
            self.papirus_theme_combobox.config(state=tk.NORMAL)
            self.papirus_version_combobox.config(state=tk.NORMAL)
            self.set_button.config(state=tk.NORMAL)
            self.install_button.config(state=tk.NORMAL)

        if get_desktop_environment() == "xfce":
            theme_legacy_button.config(
                text="XFCE Theme", state=tk.NORMAL, command=xfce_theme_
            )
            self.papirus_theme_combobox.config(state=tk.NORMAL)
            self.papirus_version_combobox.config(state=tk.NORMAL)
            self.set_button.config(state=tk.NORMAL)
            self.install_button.config(state=tk.NORMAL)

        self.wp_gallery = LabelFrame(
            self,
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            highlightthickness=0,
            highlightcolor="white",
            text="Wallpaper Gallery",
            background=maincolor,
            pady=10,
        )
        self.wp_gallery.pack(pady=20, padx=40, fill="both", expand=True, anchor="n")

        # Create a Canvas widget to hold the content of wp_frame
        self.canvas = Canvas(self.wp_gallery, borderwidth=0, highlightthickness=0)
        self.canvas.pack(side="left", fill="both", expand=True)

        # Add a Scrollbar and link it to the Canvas for scrolling
        self.scrollbar = ttk.Scrollbar(self.wp_gallery, command=self.canvas.yview)
        self.scrollbar.pack(side="right", fill="y")
        self.canvas.config(background=maincolor, yscrollcommand=self.scrollbar.set)

        # Create wp_frame as a child of the Canvas
        self.wp_frame = Frame(self.canvas, background=maincolor)
        self.canvas.create_window((0, 0), window=self.wp_frame, anchor="nw")

        # Bind the Canvas to configure the scroll region when the frame size changes
        self.wp_frame.bind("<Configure>", self.configure_canvas)

        self.thumbnails_frame = None  # Initialize thumbnails_frame here
        self.thumbnails = []

        self.home_dir = os.path.expanduser("~")
        self.config_dir = os.path.join(self.home_dir, ".pigro")
        os.makedirs(self.config_dir, exist_ok=True)

        self.wallpaper_dir = None
        self.load_wallpaper_list()

        # self.add_content()

    def set_wallpapers(self, image_path):
        try:
            if get_desktop_environment() == "lxde-pi-wayfire":
                os.popen(f"pcmanfm --set-wallpaper {image_path}")
            elif get_desktop_environment() == "lxde":
                os.popen(f"pcmanfm --set-wallpaper {image_path}")
            elif get_desktop_environment() == "xfce":
                os.popen(
                    f"xfconf-query -c xfce4-desktop -p insert_property_here -s {image_path}"
                )
            elif get_desktop_environment() == "mate":
                subprocess.run(
                    [
                        "gsettings",
                        "set",
                        "org.mate.background",
                        "picture-filename",
                        f"{image_path}",
                    ]
                )
            elif get_desktop_environment() == "gnome":
                subprocess.run(
                    [
                        "gsettings",
                        "set",
                        "org.gnome.desktop.background",
                        "picture-uri-dark",
                        f"file://{image_path}",
                    ]
                )
                subprocess.run(
                    [
                        "gsettings",
                        "set",
                        "org.gnome.desktop.background",
                        "picture-uri",
                        f"file://{image_path}",
                    ]
                )
            print(f"Wallpaper set to: {image_path}")
        except Exception as e:
            print(f"Error setting wallpaper: {e}")

    def change_wallpaper(self, image_path):
        self.set_wallpapers(image_path)

    def select_wallpaper_directory(self):
        self.wallpaper_dir = filedialog.askdirectory(
            title="Select Wallpaper Directory", initialdir=self.home_dir
        )

        if self.wallpaper_dir:
            self.refresh_thumbnails()
            self.save_wallpaper_list()

    def save_wallpaper_list(self):
        if self.wallpaper_dir:
            data = {
                "wallpaper_dir": self.wallpaper_dir,
                "wallpapers": [img[0] for img in self.thumbnails],
            }
            config_path = os.path.join(self.config_dir, "config.json")
            with open(config_path, "w", encoding="utf-8") as config_file:
                json.dump(data, config_file)

    def load_wallpaper_list(self):
        config_path = os.path.join(self.config_dir, "config.json")
        if os.path.isfile(config_path):
            with open(config_path, "r", encoding="utf-8") as config_file:
                data = json.load(config_file)
                self.wallpaper_dir = data["wallpaper_dir"]
                self.refresh_thumbnails()

    def refresh_thumbnails(self):
        if self.thumbnails_frame is not None:
            for widget in self.thumbnails_frame.winfo_children():
                widget.destroy()

        if not self.wallpaper_dir:
            return

        image_files = [
            f
            for f in os.listdir(self.wallpaper_dir)
            if f.lower().endswith((".jpg", ".jpeg", ".png", ".gif"))
        ]

        self.thumbnails_frame = Frame(self.wp_frame, background=maincolor)
        self.thumbnails_frame.pack()

        self.row, self.col = 0, 0
        self.thumbnails = []

        for image_file in image_files:
            image_path = os.path.join(self.wallpaper_dir, image_file)
            image = Image.open(image_path)
            image.thumbnail((220, 220))
            thumbnail = ImageTk.PhotoImage(image)
            self.thumbnails.append((image_path, thumbnail))

        for image_path, thumbnail in self.thumbnails:
            button = Button(
                self.thumbnails_frame,
                image=thumbnail,
                command=lambda path=image_path: self.change_wallpaper(path),
                background=maincolor,
                borderwidth=0,
                highlightthickness=0,
            )
            button.grid(row=self.row, column=self.col, padx=5, pady=5)

            self.col += 1
            if self.col == 4:
                self.col = 0
                self.row += 1

    def add_content(self):
        # Your content creation code goes here
        for i in range(50):
            label = Label(self.wp_frame, text=f"Item {i}")
            label.pack()

    def configure_canvas(self, event):
        # Update the scroll region when the frame size changes
        self.canvas.config(scrollregion=self.canvas.bbox("all"))
