import os
from os import popen
import os.path
from tkinter import *
from tkinter import ttk
import tkinter as tk
import tkinter.font as tkFont
from threading import Thread
from PIL import ImageTk, Image
from urllib.request import urlopen
import urllib.error
import requests
import apt
from bs4 import BeautifulSoup
from resorcess import *
from apt_manage import *
import subprocess
from piapps_manage import *
from flatpak_manage import *
from flatpak_alias_list import *
from tabs.pop_ups import *
from tabs.n2h_tab_check import *
from tabs.gif_animation import ImageLabel


class SoftwareTab(ttk.Frame):
    def __init__(self, master):
        super().__init__(master)
        self.grid(row=0, column=0, sticky="nsew")

        self.inst_notebook = ttk.Notebook(self)
        self.inst_notebook.pack(fill=BOTH, expand=True)

        self.deban_navbar_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/deb_s.png"
        )
        self.debinstall_icon = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/64x64/debian-logo.png"
        )
        self.pi_appsinstall_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/pi-apps64x64.png"
        )
        self.pi_appsopen_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/piapps_logo_24x24.png"
        )
        self.pi_appssett_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/piapps_settings_24x24.png"
        )
        self.flatpak_appsinstall_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/flathub64x64.png"
        )
        self.no_img = PhotoImage(file=f"{Application_path}/images/apps/no_image.png")

        self.ok_installed = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/ok_16x16.png"
        )

        self.not_ok_installed = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/not_ok_16x16.png"
        )

        self.pi_apps_big_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pi-apps-glogo.png"
        )

        self.flatpak_big_icon = PhotoImage(
            file=f"{Application_path}/images/icons/flatpak-glogo.png"
        )

        if "dark" in get_theme().lower():
            self.deb_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/debian_dark_24x24.png"
            )

            self.piapps_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/piapps_dark_24x24.png"
            )

            self.flatpak_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/flatpak_dark_24x24.png"
            )

            self.oneclick_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/g2h_dark_24x24.png"
            )
            self.q_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/apt_queue_dark_24x24.png"
            )
            self.exit_btn = PhotoImage(
                file=f"{Application_path}/images/icons/pigro_icons/exit_btn.png"
            )
            self.search_btn = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/glass_icon.png"
            )
        else:
            self.deb_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/debian_light_24x24.png"
            )

            self.piapps_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/piapps_light_24x24.png"
            )

            self.flatpak_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/flatpak_light_24x24.png"
            )

            self.oneclick_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/g2h_light_24x24.png"
            )
            self.q_nav = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/apt_queue_light_24x24.png"
            )
            self.exit_btn = PhotoImage(
                file=f"{Application_path}/images/icons/pigro_icons/exit_btn.png"
            )
            self.search_btn = PhotoImage(
                file=f"{Application_path}/images/icons/nav_bar/glass_icon.png"
            )

        self.q_counter = 0
        # create frames
        apt_frame = ttk.Frame(self.inst_notebook)
        apt_q_frame = ttk.Frame(self.inst_notebook)
        piapps_frame = ttk.Frame(self.inst_notebook)
        flat_frame = ttk.Frame(self.inst_notebook)
        n2h_frame = ttk.Frame(self.inst_notebook)

        apt_frame.pack(fill="both", expand=True)
        apt_q_frame.pack(fill="both", expand=True)
        piapps_frame.pack(fill="both", expand=True)
        flat_frame.pack(fill="both", expand=True)
        n2h_frame.pack(fill="both", expand=True)

        # add frames to notebook

        self.inst_notebook.add(apt_frame, compound=LEFT, text="APT", image=self.deb_nav)

        self.inst_notebook.add(
            apt_q_frame,
            compound=LEFT,
            text=f"APT Queue({self.q_counter})",
            image=self.q_nav,
        )

        self.inst_notebook.add(
            piapps_frame, compound=LEFT, text="Pi Apps", image=self.piapps_nav
        )
        self.inst_notebook.add(
            flat_frame, compound=LEFT, text="Flatpak", image=self.flatpak_nav
        )
        self.inst_notebook.add(
            n2h_frame, compound=LEFT, text="Nice 2 Have", image=self.oneclick_nav
        )

        piapps_frame.columnconfigure(0, weight=1)
        piapps_frame.rowconfigure(0, weight=1)

        flat_frame.columnconfigure(0, weight=1)
        flat_frame.rowconfigure(0, weight=1)

        def error_message_0():
            e_mass = Error_Mass(self)
            e_mass.grab_set()

        def error_message_1():
            e_mass = Error_Mass(self)
            e_mass.grab_set()
            error_y2.config(text="Not in the list! Check for misspell.")

        def resize(img):
            basewidth = 400
            wpercent = basewidth / float(img.size[0])
            hsize = int((float(img.size[1]) * float(wpercent)))
            return img.resize((basewidth, hsize))

        def resize2(img):
            basewidth = 64
            wpercent = basewidth / float(img.size[0])
            hsize = int((float(img.size[1]) * float(wpercent)))
            return img.resize((basewidth, hsize))

        def put_apt_software():
            """Creates the interface for APT Search and Install/Uninstall"""

            def apt_install():
                global pigro_skript_name
                pigro_skript_name = f"Installing... {apt_entry.get()}"
                global pigro_skript
                pigro_skript = f"pkexec apt install {apt_entry.get()} -y && exit"
                custom_pop = Custom_Installer(self)
                custom_pop.grab_set()
                get_installed_apt_pkgs()
                hide_apt_frame()
                apt_search_container.pack(anchor="w", side=LEFT, pady=20, padx=10)

            def apt_uninstall():
                global pigro_skript_name
                pigro_skript_name = f"Uninstalling... {apt_entry.get()}"
                global pigro_skript
                pigro_skript = f"pkexec apt remove {apt_entry.get()} -y && exit"
                custom_pop = Custom_Installer(self)
                custom_pop.grab_set()
                get_installed_apt_pkgs()
                hide_apt_frame()
                apt_search_container.pack(anchor="w", side=LEFT, pady=20, padx=10)

            def update_apt_list(apt_data):
                apt_data = sorted(apt_data)
                apt_list_box.delete(0, END)
                for item in apt_data:
                    apt_list_box.insert(END, item)

            def apt_list_fillout(e):
                apt_entry.delete(0, END)
                apt_entry.insert(0, apt_list_box.get(ACTIVE))

            def apt_search_check(e):
                typed = apt_entry.get()
                if typed == "":
                    apt_data = get_apt_cache()
                else:
                    apt_data = []
                    for item in get_apt_cache():
                        if typed.lower() in item.lower():
                            apt_data.append(item)
                update_apt_list(apt_data)

            def get_debian_icon():
                if apt_entry.get() in apt_flatpak_matches:
                    try:
                        url_output = f"https://dl.flathub.org/repo/appstream/x86_64/icons/128x128/{apt_flatpak_matches[apt_entry.get()]}.png"
                        with urlopen(url_output) as url_output:
                            self.deban_navbar_icon = Image.open(url_output)
                        self.deban_navbar_icon = resize2(self.deban_navbar_icon)

                        self.deban_navbar_icon = ImageTk.PhotoImage(
                            self.deban_navbar_icon
                        )
                        apt_pkg_icon.config(image=self.deban_navbar_icon)
                    except urllib.error.HTTPError as e:
                        print(f"{e}")
                        apt_pkg_icon.config(image=self.debinstall_icon)
                else:
                    apt_pkg_icon.config(image=self.debinstall_icon)

            def apt_screenshot():
                try:
                    apt_app = str(apt_entry.get())
                    url = f"https://screenshots.debian.net/package/{apt_app}#gallery-1"
                    # Make an HTTP GET request to the webpage
                    response = requests.get(url)
                    # Use BeautifulSoup to parse the HTML
                    soup = BeautifulSoup(response.text, "html.parser")
                    # Find all links with .png extension
                    links = [
                        link.get("href")
                        for link in soup.find_all("a")
                        if link.get("href").endswith(".png")
                    ]

                    url_output = f"https://screenshots.debian.net{str(links[1])}"
                    with urlopen(url_output) as url_output:
                        self.app_img = Image.open(url_output)
                    self.app_img = resize(self.app_img)

                    self.app_img = ImageTk.PhotoImage(self.app_img)
                    apt_panel.config(image=self.app_img)
                except IndexError as e:
                    print(f"{e}")
                    apt_panel.config(image=self.no_img)

            def put_apt_description():
                pkg_infos = os.popen(f"apt show -a {apt_entry.get()}")
                read_pkg_infos = pkg_infos.read()

                insert_description = read_pkg_infos
                description_text.delete("1.0", "end")
                description_text.insert(END, insert_description)

            # function to update the q_treeview with data from shell commands
            def update_q_treeview():
                # execute shell commands and get the output
                package_output = subprocess.check_output(
                    f"apt show -a {apt_entry.get()} | grep -E 'Package:'", shell=True
                )
                description_output = subprocess.check_output(
                    f"apt show -a {apt_entry.get()} | grep -E 'Description:'",
                    shell=True,
                )

                # parse the output to extract the package name and description
                package = package_output.decode("utf-8").split(":")[1].strip()
                description = description_output.decode("utf-8").split(":")[1].strip()

                self.q_counter += 1
                # insert the data into the q_treeview
                q_tree.insert("", "end", text="", values=(str(package), description))
                # self.inst_notebook.apt_q_frame.config(text=f"Queue({self.q_counter})")
                self.inst_notebook.tab(apt_q_frame, text=f"Queue({self.q_counter})")
                print(
                    [q_tree.item(child)["values"][0] for child in q_tree.get_children()]
                )
                hide_apt_frame()
                apt_search_container.pack(anchor="w", side=LEFT, pady=20, padx=10)

            def hide_apt_search_container():
                apt_search_container.pack_forget()

            def apt_search():
                if apt_entry.get() == "":
                    # print("Nop")
                    error_message_0()
                elif apt_entry.get() not in get_apt_cache():
                    error_message_1()
                    # print("Nop")
                else:
                    apt_info_throber_frame.pack_forget()
                    apt_info_container.pack(fill=BOTH, expand=True, pady=20, padx=10)
                    apt_pkg_name.config(text=f"{apt_entry.get()}")

                    pkg_infos_desc = os.popen(
                        f"apt show -a {apt_entry.get()} | grep -E 'Description:'"
                    )
                    read_pkg_infos_desc = pkg_infos_desc.read()

                    apt_pkg_status.config(
                        text=f"{read_pkg_infos_desc.split(':')[1]}",
                        justify="left",
                        anchor="w",
                    )

                    if apt_entry.get() in apt_installed_content:
                        apt_pkg_inst.grid_forget()  # .config(state=DISABLED)
                        # .config(state=NORMAL)
                        apt_pkg_uninst.grid(row=0, column=2, sticky="e")
                        apt_q_inst.grid_forget()  # .config(state=DISABLED)
                    else:
                        # .config(state=NORMAL)
                        apt_pkg_inst.grid(row=0, column=2, sticky="e")
                        apt_pkg_uninst.grid_forget()  # .config(state=DISABLED)
                        apt_q_inst.grid(row=1, column=2, pady=5, sticky="e")

                    apt_panel.config(image=self.no_img)

                    get_debian_icon()
                    apt_screenshot()
                    put_apt_description()
                    hide_apt_search_container()

            def hide_apt_frame():
                apt_info_container.pack_forget()
                apt_search_container.pack(anchor="w", side=LEFT, pady=20, padx=10)
                apt_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            apt_main_container = Frame(apt_frame, background=maincolor)
            apt_main_container.pack(fill="both", expand=True)

            apt_search_container = LabelFrame(
                apt_main_container,  # apt_frame,
                text="Search",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            apt_search_container.pack(anchor="w", side=LEFT, pady=20, padx=10)

            apt_search_field = Frame(
                apt_search_container,  # apt_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            apt_search_field.pack(fill="x", pady=5)

            apt_entry = Entry(
                apt_search_field, font=("Sans", 15), borderwidth=0, highlightthickness=0
            )
            apt_entry.pack(fill="x", expand=True, side="left")

            apt_search_btn = Button(
                apt_search_field,
                image=self.search_btn,
                text="Select",
                bg=ext_btn,
                fg=main_font,
                borderwidth=0,
                highlightthickness=0,
                command=apt_search,
            )
            apt_search_btn.pack(side="right", fill="both")  # fill="x")

            apt_list_box = Listbox(
                apt_search_container,
                height=59,
                width=40,
                borderwidth=1,
                highlightthickness=0,
            )
            apt_list_box_scrollbar = ttk.Scrollbar(apt_search_container)
            apt_list_box_scrollbar.pack(side=RIGHT, fill=Y)
            apt_list_box.config(yscrollcommand=apt_list_box_scrollbar.set)
            apt_list_box_scrollbar.config(command=apt_list_box.yview)
            apt_list_box.pack(fill=BOTH)

            update_apt_list(get_apt_cache())

            apt_list_box.bind("<<ListboxSelect>>", apt_list_fillout)

            apt_entry.bind("<KeyRelease>", apt_search_check)

            apt_info_throber_frame = Frame(
                apt_main_container, background=maincolor  # apt_frame,
            )
            apt_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            anim = ImageLabel(
                apt_info_throber_frame,
                highlightthickness=0,
                borderwidth=0,
                background=maincolor,
            )
            anim.pack(fill=BOTH, expand=True)
            # anim.load(f"{Application_path}/images/icons/loader_search.gif")

            if "dark" in get_theme().lower():
                anim.load(f"{Application_path}/images/icons/loader_search.gif")

            else:
                anim.load(f"{Application_path}/images/icons/loader_search_light.gif")

            apt_info_container = Frame(
                apt_main_container, background=maincolor  # apt_frame,
            )

            apt_pkg_info_frame = Frame(
                apt_info_container,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                background=frame_color,
            )
            apt_pkg_info_frame.pack(anchor="n", fill="x")

            apt_exit = Button(
                apt_pkg_info_frame,
                text="exit",
                image=self.exit_btn,
                background=frame_color,
                foreground="white",
                borderwidth=0,
                highlightthickness=0,
                command=hide_apt_frame,
                # state=DISABLED,
            )
            apt_exit.pack(side=RIGHT)

            apt_pkg_info_frame = LabelFrame(
                apt_info_container,
                text="Package Information",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            apt_pkg_info_frame.pack(anchor="n", fill="x")

            apt_pkg_info_container = Frame(
                apt_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            apt_pkg_info_container.pack(fill="x")
            apt_pkg_info_container.columnconfigure(1, weight=2)

            apt_pkg_icon = Label(
                apt_pkg_info_container,
                image=self.debinstall_icon,
                font=font_10_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                padx=10,
            )
            apt_pkg_icon.grid(row=0, rowspan=2, column=0)  # .pack()

            apt_pkg_name = Label(
                apt_pkg_info_container,
                text="",
                font=font_16_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            apt_pkg_name.grid(row=0, column=1, sticky="ew")

            apt_pkg_status = Label(
                apt_pkg_info_container,
                text="",
                font=font_8,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            apt_pkg_status.grid(row=1, column=1, sticky="ew")

            apt_pkg_inst = Button(
                apt_pkg_info_container,
                text="Install",
                justify="left",
                width=10,
                background="#6abd43",
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=apt_install,
            )

            apt_q_inst = Button(
                apt_pkg_info_container,
                text="Queue",
                justify="left",
                width=10,
                background=ext_btn,
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=update_q_treeview,
            )

            apt_pkg_uninst = Button(
                apt_pkg_info_container,
                text="Uninstall",
                justify="left",
                width=10,
                background="#f04a50",
                foreground="white",
                font=font_10_b,
                borderwidth=0,
                highlightthickness=0,
                command=apt_uninstall,
            )

            apt_pkg_img_frame = LabelFrame(
                apt_info_container,
                text="Screenshot",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            apt_pkg_img_frame.pack(anchor="n", fill=BOTH, expand=True, pady=20)

            apt_panel = Label(apt_pkg_img_frame, bg=frame_color)
            apt_panel.pack(fill="both", expand="yes")

            apt_pkg_info_frame = LabelFrame(
                apt_info_container,
                text="Details",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            apt_pkg_info_frame.pack(anchor="n", fill=BOTH, expand=True)

            description_text = Text(
                apt_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
                foreground=main_font,
                font=("Sans", 9),
            )
            description_text.pack(side=LEFT, fill=BOTH, expand=True)

            description_scrollbar = ttk.Scrollbar(
                apt_pkg_info_frame, orient=VERTICAL, command=description_text.yview
            )
            description_text.configure(yscrollcommand=description_scrollbar.set)
            description_scrollbar.pack(side=LEFT, fill=Y)

            # 1 Click Tab

            # APT Queue Tab
            # create the treeview with headers

            self.q_list_tree_frame = LabelFrame(
                apt_q_frame,
                text="APT Queue",
                font=font_16,
                foreground=label_frame_color,
                relief=GROOVE,
                borderwidth=0,
                highlightthickness=0,
                highlightcolor="white",
                padx=30,
                pady=10,
            )
            self.q_list_tree_frame["background"] = frame_color
            self.q_list_tree_frame.pack(fill="both", expand=True, pady=20, padx=20)

            # create the treeview with headers
            q_tree = ttk.Treeview(
                self.q_list_tree_frame, columns=("Application", "Description")
            )

            # set the headings for the columns
            q_tree.heading("#0", text="", anchor="w")
            q_tree.column("#0", width=0)
            q_tree.heading("#1", text="Application", anchor="w")
            q_tree.heading("#2", text="Description", anchor="w")

            # function to generate a string of all the applications in the q_treeview

            def generate_install_string():
                # get all the applications from the q_treeview
                all_app = " ".join(
                    [
                        str(q_tree.item(child)["values"][0])
                        for child in q_tree.get_children()
                    ]
                )

                # create the install command string
                to_install = f"{all_app}"
                global pigro_skript_name
                pigro_skript_name = f"Installing... Queue"
                global pigro_skript
                pigro_skript = f"pkexec apt install {to_install} -y && exit"
                custom_pop = Custom_Installer(self)
                custom_pop.grab_set()

                for child in q_tree.get_children():
                    q_tree.delete(child)
                self.q_counter = 0
                self.inst_notebook.tab(apt_q_frame, text=f"Queue({self.q_counter})")

                apt_pkg_icon.config(image=self.debinstall_icon)
                apt_pkg_name.config(text="Name:")
                apt_pkg_status.config(text="Status:")
                apt_pkg_inst.config(state=DISABLED)
                apt_q_inst.config(state=DISABLED)
                apt_pkg_uninst.config(state=DISABLED)
                description_text.delete("1.0", "end")

            # function to remove all entries from the q_treeview

            def clear_q_treeview():
                # delete all entries in the q_treeview
                for child in q_tree.get_children():
                    q_tree.delete(child)
                self.q_counter = 0
                self.inst_notebook.tab(apt_q_frame, text=f"Queue({self.q_counter})")

            q_btn_frame = Frame(self.q_list_tree_frame, pady=5, background=frame_color)

            def del_selected():
                self.q_counter -= 1
                q_tree.delete(q_tree.selection())
                self.inst_notebook.tab(apt_q_frame, text=f"Queue({self.q_counter})")

            # create the button to remove the selected line from the q_treeview
            q_remove_button = tk.Button(
                q_btn_frame,
                text="Remove Selected",
                justify="left",
                width=15,
                background=ext_btn,
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=del_selected,
            )

            # create the button to generate the install command string
            q_install_button = tk.Button(
                q_btn_frame,
                text="Install Queue",
                justify="left",
                width=15,
                background=ext_btn,
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=generate_install_string,
            )

            # create the button to clear the q_treeview
            q_clear_button = tk.Button(
                q_btn_frame,
                text="Clear All",
                justify="left",
                width=15,
                background=ext_btn,
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=clear_q_treeview,
            )

            # add the buttons and q_treeview to the window
            q_tree.pack(fill="both", expand=True)
            q_btn_frame.pack(fill="x")
            q_install_button.pack(side=LEFT)
            q_remove_button.pack(side=LEFT, padx=5)
            q_clear_button.pack(side=LEFT)

        put_apt_software()

        def put_piapps_software():
            # pi apps_entry

            def hide_piapps_frame():
                piapps_info_frame.pack_forget()
                piapps_search_frame.pack(anchor="w", side=LEFT, pady=20, padx=10)
                piapps_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            def piapps_install():
                fullstring = piapps_entry.get()
                substring = " "
                if substring in fullstring:
                    replace_space = fullstring.replace(" ", "\ ")
                    popen(
                        f"x-terminal-emulator -e 'bash -c \"~/pi-apps/manage install {replace_space}; exec bash\"'"
                    )
                    piapps_installed_content.append(piapps_entry.get())
                    piapps_pkg_uninst.config(state=NORMAL)
                    piapps_pkg_inst.config(state=DISABLED)

                else:
                    popen(
                        f"x-terminal-emulator -e 'bash -c \"~/pi-apps/manage install {piapps_entry.get()}; exec bash\"'"
                    )
                    piapps_installed_content.append(piapps_entry.get())
                    for item in piapps_installed_content:
                        if item == piapps_entry.get():
                            piapps_pkg_uninst.config(state=NORMAL)
                            piapps_pkg_inst.config(state=DISABLED)
                hide_piapps_frame()

                piapps_pkg_status.config(
                    text="Installed",
                    compound="left",
                    justify="left",
                    image=self.ok_installed,
                    anchor="w",
                    width=150,
                )

            def piapps_uninstall():
                fullstring = piapps_entry.get()
                substring = " "
                if substring in fullstring:
                    replace_space = fullstring.replace(" ", "\ ")
                    popen(
                        f"x-terminal-emulator -e 'bash -c \"~/pi-apps/manage uninstall {replace_space}; exec bash\"'"
                    )
                    piapps_installed_content.remove(piapps_entry.get())
                    piapps_pkg_uninst.config(state=DISABLED)
                    piapps_pkg_inst.config(state=NORMAL)
                else:
                    popen(
                        f"x-terminal-emulator -e 'bash -c \"~/pi-apps/manage uninstall {piapps_entry.get()}; exec bash\"'"
                    )
                    piapps_installed_content.remove(piapps_entry.get())
                    for item in piapps_installed_content:
                        if item == piapps_entry.get():
                            piapps_pkg_uninst.config(state=NORMAL)
                            piapps_pkg_inst.config(state=DISABLED)
                        else:
                            piapps_pkg_uninst.config(state=DISABLED)
                            piapps_pkg_inst.config(state=NORMAL)
                hide_piapps_frame()

                piapps_pkg_status.config(
                    text="Not Installed",
                    compound="left",
                    justify="left",
                    image=self.not_ok_installed,
                    anchor="w",
                    width=150,
                )

            def update_piapps(piapps_data):
                piapps_list_box.delete(0, END)
                for item in piapps_data:
                    piapps_list_box.insert(END, item)

            def piapps_fillout(e):
                piapps_entry.delete(0, END)
                piapps_entry.insert(0, piapps_list_box.get(ACTIVE))

            def piapps_search_check(e):
                typed = piapps_entry.get()
                if typed == "":
                    piapps_data = piapps_cache_content
                else:
                    piapps_data = []
                    for item in piapps_cache_content:
                        if typed.lower() in item.lower():
                            piapps_data.append(item)
                update_piapps(piapps_data)

            def piapps_search():
                piapps_panel.config(image=self.no_img)
                if piapps_entry.get() == "":
                    # print("Nop")
                    error_message_0()
                elif piapps_entry.get() not in piapps_cache_content:
                    error_message_1()
                    # print("Nop")
                else:
                    piapps_info_throber_frame.pack_forget()
                    piapps_info_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)
                    piapps_pkg_name.config(text=f"{piapps_entry.get()}")
                    if piapps_entry.get() in piapps_installed_content:
                        piapps_pkg_inst.grid_forget()  # .config(state=DISABLED)
                        # .config(state=NORMAL)
                        piapps_pkg_uninst.grid(row=0, column=2, sticky="e")
                    else:
                        # .config(state=NORMAL)
                        piapps_pkg_inst.grid(row=0, column=2, sticky="e")
                        piapps_pkg_uninst.grid_forget()  # .config(state=DISABLED)

                    app_string = f"{piapps_entry.get()}"
                    app_string_web = app_string.replace(" ", "%20")

                    self.piapps_select_icon = PhotoImage(
                        file=f"~/pi-apps/apps/{piapps_entry.get()}/icon-64.png"
                    )
                    piapps_pkg_icon.config(image=self.piapps_select_icon)

                    piapps_pkg_infos = open(
                        f"{home}/pi-apps/apps/{piapps_entry.get()}/description",
                        "r",
                    )
                    read_piapps_pkg_infos = piapps_pkg_infos.read()

                    insert_piapps_description = read_piapps_pkg_infos
                    piapps_description_text.delete("1.0", "end")
                    piapps_description_text.insert(END, insert_piapps_description)

                    try:
                        url_output = f"https://github.com/actionschnitzel/PiGro-Aid-/blob/data/screenshots/pi-apps/{app_string_web}.png?raw=true"
                        with urlopen(url_output) as url_output:
                            self.img = Image.open(url_output)
                        self.img = resize(self.img)

                        self.img = ImageTk.PhotoImage(self.img)
                        piapps_panel.config(image=self.img)
                    except urllib.error.HTTPError as e:
                        print(f"{e}")
                        piapps_panel.config(image=self.no_img)

                    piapps_search_frame.pack_forget()

            pi_apps_main_container = Frame(piapps_frame, background=maincolor)
            pi_apps_main_container.pack(fill="both", expand=True)

            def install_piapps_apt():
                popen(
                    f"x-terminal-emulator -e 'bash -c \"wget -qO- https://raw.githubusercontent.com/Botspot/pi-apps/master/install | bash; exec bash\"'"
                )

            if piapps_path == False:
                pi_apps_main_container.pack_forget()

                pi_apps_not_installad_container = Frame(
                    piapps_frame, background=maincolor
                )
                pi_apps_not_installad_container.grid(row=0, column=0, sticky="nesw")

                piapps_big_icon = Label(
                    pi_apps_not_installad_container,
                    image=self.pi_apps_big_icon,
                    font=font_10_b,
                    justify="left",
                    background=maincolor,
                    foreground=main_font,
                )
                piapps_big_icon.pack(anchor="center", pady=20)

                piapps_app_inst = Button(
                    pi_apps_not_installad_container,
                    text="Install Pi-Apps",
                    justify="left",
                    width=20,
                    background=ext_btn,
                    foreground="white",
                    font=font_10_b,
                    borderwidth=0,
                    highlightthickness=0,
                    command=install_piapps_apt,
                )
                piapps_app_inst.pack()

            piapps_search_frame = LabelFrame(
                pi_apps_main_container,
                text="Search",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            piapps_search_frame.pack(anchor="w", side=LEFT, pady=20, padx=10)

            piapps_search_field = Frame(
                piapps_search_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            piapps_search_field.pack(fill="x", pady=5)

            piapps_entry = Entry(
                piapps_search_field,
                font=("Sans", 15),
                borderwidth=0,
                highlightthickness=0,
            )
            piapps_entry.pack(fill="x", expand=True, side="left")

            piapps_search_btn = Button(
                piapps_search_field,
                image=self.search_btn,
                text="Select",
                bg=ext_btn,
                fg=main_font,
                borderwidth=0,
                highlightthickness=0,
                command=piapps_search,
            )
            piapps_search_btn.pack(side="right", fill=BOTH)

            piapps_list_box = Listbox(
                piapps_search_frame,
                height=50,
                width=40,
                borderwidth=0,
                highlightthickness=0,
            )

            piapps_list_box_scrollbar = ttk.Scrollbar(piapps_search_frame)
            piapps_list_box_scrollbar.pack(side=RIGHT, fill=Y)
            piapps_list_box.config(yscrollcommand=piapps_list_box_scrollbar.set)
            piapps_list_box_scrollbar.config(command=piapps_list_box.yview)

            piapps_list_box.pack(fill=BOTH)

            if piapps_path == True:
                piapps_cache = os.popen(f"ls ~/pi-apps/apps/ ")
                piapps_cache_content = piapps_cache.readlines()
                for i, s in enumerate(piapps_cache_content):
                    piapps_cache_content[i] = s.strip()

                piapps_installed = pi_apps_installed_list
                piapps_installed_content = piapps_installed
                for i, s in enumerate(piapps_installed_content):
                    piapps_installed_content[i] = s.strip()
                update_piapps(piapps_cache_content)

            else:
                piapps_search_btn.config(state=DISABLED)
                piapps_entry.insert(0, "Pi Apps is not installed")

            piapps_list_box.bind("<<ListboxSelect>>", piapps_fillout)

            piapps_entry.bind("<KeyRelease>", piapps_search_check)

            piapps_info_frame = Frame(pi_apps_main_container, background=maincolor)

            piapps_info_throber_frame = Frame(
                pi_apps_main_container, background=maincolor
            )
            piapps_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            piapps_anim = ImageLabel(
                piapps_info_throber_frame,
                highlightthickness=0,
                borderwidth=0,
                background=frame_color,
            )
            piapps_anim.pack(fill=BOTH, expand=True)
            # piapps_anim.load(f"{Application_path}/images/icons/loader_search.gif")
            if "dark" in get_theme().lower():
                piapps_anim.load(f"{Application_path}/images/icons/loader_search.gif")

            else:
                piapps_anim.load(
                    f"{Application_path}/images/icons/loader_search_light.gif"
                )

            piapps_info_frame = Frame(pi_apps_main_container, background=maincolor)

            piapps_menu_info_frame = Frame(
                piapps_info_frame,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                background=frame_color,
            )

            piapps_menu_info_frame.pack(anchor="n", fill="x")

            piapps_exit = Button(
                piapps_menu_info_frame,
                text="exit",
                image=self.exit_btn,
                background=frame_color,
                foreground="white",
                borderwidth=0,
                highlightthickness=0,
                command=hide_piapps_frame,
            )
            piapps_exit.pack(side=RIGHT)

            piapps_pkg_info_frame = LabelFrame(
                piapps_info_frame,
                text="Package Information",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            piapps_pkg_info_frame.pack(anchor="n", fill="x")

            piapps_pkg_info_container = Frame(
                piapps_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            piapps_pkg_info_container.pack(fill="x")
            piapps_pkg_info_container.columnconfigure(1, weight=2)

            piapps_pkg_icon = Label(
                piapps_pkg_info_container,
                image=self.pi_appsinstall_icon,
                font=font_10_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                padx=10,
            )
            piapps_pkg_icon.grid(row=0, rowspan=2, column=0)

            piapps_pkg_name = Label(
                piapps_pkg_info_container,
                text="",
                font=font_16_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            piapps_pkg_name.grid(row=0, column=1, sticky="ew")

            piapps_pkg_status = Label(
                piapps_pkg_info_container,
                text="",
                font=font_10,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            piapps_pkg_status.grid(row=1, column=1, sticky="ew")

            piapps_pkg_inst = Button(
                piapps_pkg_info_container,
                text="Install",
                justify="left",
                width=10,
                background="#6abd43",
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=piapps_install,
            )

            piapps_pkg_uninst = Button(
                piapps_pkg_info_container,
                text="Uninstall",
                justify="left",
                width=10,
                background="#f04a50",
                foreground="white",
                font=font_10_b,
                borderwidth=0,
                highlightthickness=0,
                command=piapps_uninstall,
            )

            def open_pi_apps():
                os.system(f"{home}/pi-apps/gui")

            def open_pi_apps_settings():
                popen(f"{home}/pi-apps/settings")

            piapps_configs_frame = Frame(
                piapps_pkg_info_container, background=frame_color
            )
            piapps_configs_frame.grid(row=2, column=1, pady=5)

            piapps_app_open = Button(
                piapps_configs_frame,
                justify="left",
                imag=self.pi_appsopen_icon,
                background=frame_color,
                foreground="white",
                font=font_10_b,
                borderwidth=0,
                highlightthickness=0,
                command=open_pi_apps,
            )
            piapps_app_open.grid(row=0, column=0, pady=5, padx=5)

            piapps_setting_open = Button(
                piapps_configs_frame,
                image=self.pi_appssett_icon,
                justify="left",
                background=frame_color,
                foreground="white",
                font=font_10_b,
                borderwidth=0,
                highlightthickness=0,
                command=open_pi_apps_settings,
            )
            piapps_setting_open.grid(row=0, column=1, pady=5, padx=5)

            if piapps_path == False:
                piapps_app_open.config(state=DISABLED)
                piapps_setting_open.config(state=DISABLED)

            piapps_pkg_img_frame = LabelFrame(
                piapps_info_frame,
                text="Screenshot",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            piapps_pkg_img_frame.pack(anchor="n", fill=BOTH, expand=True, pady=20)

            piapps_panel = Label(piapps_pkg_img_frame, bg=frame_color)
            piapps_panel.pack(fill="both", expand="yes")

            piapps_pkg_info_frame = LabelFrame(
                piapps_info_frame,
                text="Details",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            piapps_pkg_info_frame.pack(anchor="n", fill=BOTH, expand=True)

            piapps_description_text = Text(
                piapps_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
                foreground=main_font,
                font=("Sans", 9),
            )
            piapps_description_text.pack(side=LEFT, fill=BOTH, expand=True)

            piapps_description_scrollbar = ttk.Scrollbar(
                piapps_pkg_info_frame,
                orient=VERTICAL,
                command=piapps_description_text.yview,
            )
            piapps_description_text.configure(
                yscrollcommand=piapps_description_scrollbar.set
            )
            piapps_description_scrollbar.pack(side=LEFT, fill=Y)

        put_piapps_software()
        # flatpak_entry

        def put_flatpak_software():
            def hide_flatpak_frame():
                flatpak_info_frame.pack_forget()
                flatpak_search_frame.pack(anchor="w", side=LEFT, pady=20, padx=10)
                flatpak_info_throber_frame.pack(
                    fill=BOTH, expand=True, pady=20, padx=10
                )

            def flatpak_install():
                global pigro_skript_name
                pigro_skript_name = f"Installing... {flatpak_entry.get()}"
                global pigro_skript
                pigro_skript = f"flatpak install flathub {Flat_remote_dict[flatpak_entry.get()]} -y && exit"
                custom_pop = Custom_Installer(self)
                custom_pop.grab_set()

                for key, value in Flat_remote_dict.items():
                    if key == flatpak_entry.get():
                        flat_uninstalled_dict[key] = value
                        flatpak_pkg_uninst.config(state=NORMAL)
                        flatpak_pkg_inst.config(state=DISABLED)

                flatpak_pkg_status.config(
                    text="Installed",
                    compound="left",
                    justify="left",
                    image=self.ok_installed,
                    anchor="w",
                    width=150,
                )
                hide_flatpak_frame()

            def flatpak_uninstall():
                global pigro_skript_name
                pigro_skript_name = f"Uninstalling... {flatpak_entry.get()}"
                global pigro_skript
                pigro_skript = f"flatpak uninstall flathub {Flat_remote_dict[flatpak_entry.get()]} -y && exit"
                custom_pop = Custom_Installer(self)
                custom_pop.grab_set()

                for key, value in Flat_remote_dict.items():
                    if key == flatpak_entry.get():
                        del flat_uninstalled_dict[key]
                        flatpak_pkg_uninst.config(state=DISABLED)
                        flatpak_pkg_inst.config(state=NORMAL)

                flatpak_pkg_status.config(
                    text="Not Installed",
                    compound="left",
                    justify="left",
                    image=self.not_ok_installed,
                    anchor="w",
                    width=150,
                )
                hide_flatpak_frame()

            def update_flatpak(flatpak_data):
                flatpak_data = sorted(flatpak_data)
                flatpak_list_box.delete(0, END)
                for item in flatpak_data:
                    flatpak_list_box.insert(END, item)

            def flatpak_fillout(e):
                flatpak_entry.delete(0, END)
                flatpak_entry.insert(0, flatpak_list_box.get(ACTIVE))

            def flatpak_search_check(e):
                typed = flatpak_entry.get()
                if typed == "":
                    flatpak_data = Flat_remote_dict.keys()
                else:
                    flatpak_data = []
                    for item in Flat_remote_dict.keys():
                        if typed.lower() in item.lower():
                            flatpak_data.append(item)
                update_flatpak(flatpak_data)

            def url_exists(flat_url):
                """
                Check if the given URL exists.
                """
                try:
                    response = requests.head(flat_url)
                    return response.status_code == 200
                except requests.exceptions.RequestException:
                    return False

            def get_flatpak_icon():
                try:
                    url_output = f"https://dl.flathub.org/repo/appstream/x86_64/icons/128x128/{Flat_remote_dict[flatpak_entry.get()]}.png"
                    with urlopen(url_output) as url_output:
                        self.flat_icon = Image.open(url_output)
                    self.flat_icon = resize2(self.flat_icon)

                    self.flat_icon = ImageTk.PhotoImage(self.flat_icon)
                    flatpak_pkg_icon.config(image=self.flat_icon)
                except urllib.error.HTTPError as e:
                    print(f"{e}")
                    flatpak_pkg_icon.config(image=self.flatpak_appsinstall_icon)

            def get_flatpak_screenshot():
                url = (
                    f"https://flathub.org/apps/{Flat_remote_dict[flatpak_entry.get()]}"
                )

                try:
                    # Der zu suchende Teilinhalt
                    desired_content = f"https://dl.flathub.org/repo/screenshots/{Flat_remote_dict[flatpak_entry.get()]}-stable/752x423/"

                    # Die Webseite herunterladen
                    web_content = requests.get(url).text

                    # Verwenden von re (regulären Ausdrücken), um die gewünschte URL zu extrahieren
                    match = re.search(rf'({desired_content}[^"\s]+)', web_content)

                    # Überprüfen, ob der gewünschte Inhalt gefunden wurde
                    if match:
                        extracted_url = match.group(1)
                        print("Gefundener Teilinhalt:", extracted_url)
                        og_image_content = extracted_url
                        # return og_image_content
                        with urlopen(og_image_content) as url_output:
                            self.img = Image.open(url_output)
                        self.img = resize(self.img)
                        self.img = ImageTk.PhotoImage(self.img)
                        flatpak_panel.config(image=self.img)

                    else:
                        print("No og:image meta property found.")
                        flatpak_panel.config(self.no_img)
                except requests.exceptions.RequestException as e:
                    print("Error fetching URL:", e)
                    return None

            def get_flatpak_description():
                url = (
                    f"https://flathub.org/apps/{Flat_remote_dict[flatpak_entry.get()]}"
                )
                print(url)
                # Send a GET request to the URL
                response = requests.get(url)
                # Use BeautifulSoup to parse the HTML content of the response
                soup = BeautifulSoup(response.content, "html.parser")
                # Find the HTML element with the specified class
                prose_element = soup.find(
                    "div", {"class": "prose dark:prose-invert xl:max-w-[75%]"}
                )
                # Print the contents of the element
                flatpak_description_text.delete("1.0", "end")
                flatpak_description_text.insert(tk.END, prose_element.text)

            def flatpak_search():
                flatpak_pkg_icon.config(image=self.flatpak_appsinstall_icon)
                flatpak_panel.config(image=self.no_img)
                if flatpak_entry.get() == "":
                    # print("Nop")
                    error_message_0()
                elif flatpak_entry.get() not in Flat_remote_dict.keys():
                    error_message_1()
                    # print("Nop")
                else:
                    flatpak_info_throber_frame.pack_forget()
                    flatpak_info_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)
                    flatpak_pkg_name.config(text=f"{flatpak_entry.get()}")
                    if flatpak_entry.get() in flat_uninstalled_dict.keys():
                        flatpak_pkg_inst.grid_forget()
                        # .config(state=NORMAL)
                        flatpak_pkg_uninst.grid(row=0, column=2, sticky="e")
                    else:
                        # .config(state=NORMAL)
                        flatpak_pkg_inst.grid(row=0, column=2, sticky="e")
                        flatpak_pkg_uninst.grid_forget()

                    get_flatpak_icon()
                    get_flatpak_screenshot()
                    get_flatpak_description()
                    flatpak_search_frame.forget()

            flatpak_inst_main_frame = Frame(flat_frame, background=maincolor)
            flatpak_inst_main_frame.pack(fill="both", expand=True)

            def install_flatpak_apt():
                popen(
                    f"x-terminal-emulator -e 'bash -c \"sudo apt install flatpak && flatpak remote-add --if-not-exists flathub https://dl.flathub.org/repo/flathub.flatpakrepo | bash; exec bash\"'"
                )

            #

            if flatpak_path == False:
                flatpak_inst_main_frame.pack_forget()

                flat_not_installad_container = Frame(flat_frame, background=maincolor)
                flat_not_installad_container.grid(row=0, column=0, sticky="nesw")

                flat_big_icon = Label(
                    flat_not_installad_container,
                    image=self.flatpak_big_icon,
                    font=font_10_b,
                    justify="left",
                    background=maincolor,
                    foreground=main_font,
                )
                flat_big_icon.pack(anchor="center", pady=20)

                flat_app_inst = Button(
                    flat_not_installad_container,
                    text="Install Flatpak",
                    justify="left",
                    width=20,
                    background=ext_btn,
                    foreground="white",
                    font=font_10_b,
                    borderwidth=0,
                    highlightthickness=0,
                    command=install_flatpak_apt,
                )
                flat_app_inst.pack()

            flatpak_search_frame = LabelFrame(
                flatpak_inst_main_frame,
                text="Search",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            flatpak_search_frame.pack(anchor="w", side=LEFT, pady=20, padx=10)

            flatpak_search_field = Frame(
                flatpak_search_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            flatpak_search_field.pack(fill="x", pady=5)

            flatpak_entry = Entry(
                flatpak_search_field,
                font=("Sans", 15),
                borderwidth=0,
                highlightthickness=0,
            )
            flatpak_entry.pack(fill="x", expand=True, side="left")

            flatpak_search_btn = Button(
                flatpak_search_field,
                image=self.search_btn,
                text="Select",
                bg=ext_btn,
                fg=main_font,
                borderwidth=0,
                highlightthickness=0,
                command=flatpak_search,
            )
            flatpak_search_btn.pack(side="right", fill=BOTH)

            flatpak_list_box = Listbox(
                flatpak_search_frame,
                height=50,
                width=40,
                borderwidth=0,
                highlightthickness=0,
            )

            flatpak_list_scrollbar = ttk.Scrollbar(flatpak_search_frame)
            flatpak_list_scrollbar.pack(side=RIGHT, fill=Y)
            flatpak_list_box.config(yscrollcommand=flatpak_list_scrollbar.set)
            flatpak_list_scrollbar.config(command=flatpak_list_box.yview)

            flatpak_list_box.pack(fill=BOTH)

            if flatpak_path == True:
                # VARs for Flatpak remote list
                f1 = "flatpak remote-ls --columns=name"
                f2 = "flatpak remote-ls --columns=application"

                # Get Name Key
                flat_name_content = os.popen(f1)
                flat_name_list = flat_name_content.readlines()
                for i1, s1 in enumerate(flat_name_list):
                    flat_name_list[i1] = s1.strip()

                # Get App Key
                flat_app_content = os.popen(f2)
                flat_app_list = flat_app_content.readlines()
                for i2, s2 in enumerate(flat_app_list):
                    flat_app_list[i2] = s2.strip()

                # Zips NAME & APP
                zip_name_app = zip(flat_name_list, flat_app_list)

                # Puts zip_name_app in dict
                Flat_remote_dict = dict(zip_name_app)

                # print(Flat_remote_dict)

                fu1 = "flatpak list --columns=name"
                fu2 = "flatpak list --columns=application"

                # Get Name Key
                flat_un_name_content = os.popen(fu1)
                flat_un_name_list = flat_un_name_content.readlines()
                for i3, s3 in enumerate(flat_un_name_list):
                    flat_un_name_list[i3] = s3.strip()

                # Get App Key
                flat_un_app_content = os.popen(fu2)
                flat_un_app_list = flat_un_app_content.readlines()
                for i4, s4 in enumerate(flat_un_app_list):
                    flat_un_app_list[i4] = s4.strip()

                # Zips NAME & APP
                zip_un_name_app = zip(flat_un_name_list, flat_un_app_list)

                # Puts zip_un_name_app in dict
                flat_uninstalled_dict = dict(zip_un_name_app)

                update_flatpak(Flat_remote_dict.keys())
                # print(flat_uninstalled_dict)

            else:
                flatpak_search_btn.config(state=DISABLED)
                flatpak_entry.insert(0, "Flatpak is not installed")

            flatpak_list_box.bind("<<ListboxSelect>>", flatpak_fillout)
            flatpak_entry.bind("<KeyRelease>", flatpak_search_check)

            flatpak_info_frame = Frame(flatpak_inst_main_frame, background=maincolor)

            flatpak_info_throber_frame = Frame(
                flatpak_inst_main_frame, background=maincolor
            )
            flatpak_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            flatpak_anim = ImageLabel(
                flatpak_info_throber_frame,
                highlightthickness=0,
                borderwidth=0,
                background=frame_color,
            )
            flatpak_anim.pack(fill=BOTH, expand=True)
            # flatpak_anim.load(f"{Application_path}/images/icons/loader_search.gif")

            if "dark" in get_theme().lower():
                flatpak_anim.load(f"{Application_path}/images/icons/loader_search.gif")

            else:
                flatpak_anim.load(
                    f"{Application_path}/images/icons/loader_search_light.gif"
                )

            flatpak_pkg_info_frame = Frame(
                flatpak_info_frame,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                background=frame_color,
            )
            flatpak_pkg_info_frame.pack(anchor="n", fill="x")

            flatpak_exit = Button(
                flatpak_pkg_info_frame,
                text="exit",
                image=self.exit_btn,
                background=frame_color,
                foreground="white",
                borderwidth=0,
                highlightthickness=0,
                command=hide_flatpak_frame,
            )
            flatpak_exit.pack(side=RIGHT)

            flatpak_pkg_info_frame = LabelFrame(
                flatpak_info_frame,
                text="Package Information",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            flatpak_pkg_info_frame.pack(anchor="n", fill="x")

            flatpak_pkg_info_container = Frame(
                flatpak_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            flatpak_pkg_info_container.pack(fill="x")
            flatpak_pkg_info_container.columnconfigure(1, weight=2)

            flatpak_pkg_icon = Label(
                flatpak_pkg_info_container,
                image=self.debinstall_icon,
                font=font_10_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                padx=10,
            )
            flatpak_pkg_icon.grid(row=0, rowspan=2, column=0)

            flatpak_pkg_name = Label(
                flatpak_pkg_info_container,
                text="",
                font=font_16_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            flatpak_pkg_name.grid(row=0, column=1, sticky="ew")

            flatpak_pkg_status = Label(
                flatpak_pkg_info_container,
                text="",
                font=font_8,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            flatpak_pkg_status.grid(row=1, column=1, sticky="ew")

            flatpak_pkg_inst = Button(
                flatpak_pkg_info_container,
                text="Install",
                justify="left",
                width=10,
                background="#6abd43",
                foreground="white",
                font=font_10,
                borderwidth=0,
                highlightthickness=0,
                command=flatpak_install,
            )

            flatpak_pkg_uninst = Button(
                flatpak_pkg_info_container,
                text="Uninstall",
                justify="left",
                width=10,
                background="#f04a50",
                foreground="white",
                font=font_10_b,
                borderwidth=0,
                highlightthickness=0,
                command=flatpak_uninstall,
            )

            def install_flatpak_apt():
                popen(
                    f"x-terminal-emulator -e 'bash -c \"sudo apt install flatpak -y && flatpak remote-add --if-not-exists flathub https://flathub.org/repo/flathub.flatpakrepo; exec bash\"'"
                )

            if flatpak_path == False:
                flatpak_app_inst = Button(
                    flatpak_pkg_info_container,
                    text="Install Flatpak",
                    justify="left",
                    width=20,
                    background=ext_btn,
                    foreground="white",
                    font=font_10_b,
                    borderwidth=0,
                    highlightthickness=0,
                    command=install_flatpak_apt,
                )
                flatpak_app_inst.grid(row=2, column=0, columnspan=2)

            flatpak_pkg_img_frame = LabelFrame(
                flatpak_info_frame,
                text="Screenshot",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            flatpak_pkg_img_frame.pack(anchor="n", fill=BOTH, expand=True, pady=20)

            flatpak_panel = Label(flatpak_pkg_img_frame, bg=frame_color)
            flatpak_panel.pack(fill="both", expand="yes")

            flatpak_pkg_info_frame = LabelFrame(
                flatpak_info_frame,
                text="Details",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            flatpak_pkg_info_frame.pack(anchor="n", fill=BOTH, expand=True)

            flatpak_description_text = Text(
                flatpak_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
                foreground=main_font,
            )
            flatpak_description_text.pack(side=LEFT, fill=BOTH, expand=True)
            flatpak_description_text.insert(
                END,
                "Install Flatpak:\nsudo apt install flatpak\nflatpak remote-add --if-not-exists flathub https://flathub.org/repo/flathub.flatpakrepo\nreboot",
            )

            flatpak_flatpak_description_text = ttk.Scrollbar(
                flatpak_pkg_info_frame,
                orient=VERTICAL,
                command=flatpak_description_text.yview,
            )
            flatpak_description_text.configure(
                yscrollcommand=flatpak_flatpak_description_text.set
            )
            flatpak_flatpak_description_text.pack(side=LEFT, fill=Y)

        put_flatpak_software()

        n2h_main_container = Frame(n2h_frame, background=maincolor)
        n2h_main_container.pack(fill="both", expand=True)

        def callback(event):
            webbrowser.open_new(event.widget.cget("text"))

        def put_n2h_software():
            def show_selected_n2h():
                for app_name, app_data in n2h_search_list.items():
                    if n2h_search_listbox.get(ANCHOR) == app_name:
                        n2h_pkg_name.config(text=app_data["name"])
                        n2h_pkg_status.config(
                            text=app_data["status_url"],
                            cursor="hand2",
                        )
                        self.n2h_sh = PhotoImage(file=app_data["screenshot"])
                        n2h_panel.config(image=self.n2h_sh)
                        n2h_description_text.delete("1.0", END)
                        n2h_description_text.insert(END, app_data["description"])

            def n2h_flatpak_frame():
                n2h_info_container.pack_forget()
                n2h_search_container.pack(
                    anchor="w", side=LEFT, pady=20, padx=10, fill="y"
                )
                n2h_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            def n2h_search_command():
                n2h_search_container.pack_forget()
                n2h_info_throber_frame.pack_forget()
                print(n2h_search_listbox.get(ANCHOR))
                n2h_info_container.pack(fill=BOTH, expand=True, pady=20, padx=10)
                show_selected_n2h()

            n2h_search_container = LabelFrame(
                n2h_main_container,
                text="Search",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            n2h_search_container.pack(anchor="w", side=LEFT, pady=20, padx=10, fill="y")

            n2h_info_container = Frame(n2h_main_container, background=maincolor)

            n2h_pkg_info_frame = Frame(
                n2h_info_container,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                background=frame_color,
            )
            n2h_pkg_info_frame.pack(anchor="n", fill="x")

            n2h_exit = Button(
                n2h_pkg_info_frame,
                text="exit",
                image=self.exit_btn,
                background=frame_color,
                foreground="white",
                borderwidth=0,
                highlightthickness=0,
                command=n2h_flatpak_frame,
            )
            n2h_exit.pack(side=RIGHT)

            n2h_pkg_info_frame = LabelFrame(
                n2h_info_container,
                text="Package Information",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            n2h_pkg_info_frame.pack(anchor="n", fill="x")

            n2h_pkg_info_container = Frame(
                n2h_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
            )
            n2h_pkg_info_container.pack(fill="x")
            n2h_pkg_info_container.columnconfigure(1, weight=2)

            n2h_pkg_icon = Label(
                n2h_pkg_info_container,
                image=self.debinstall_icon,
                font=font_10_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                padx=10,
            )
            n2h_pkg_icon.grid(row=0, rowspan=2, column=0)

            n2h_pkg_name = Label(
                n2h_pkg_info_container,
                text="",
                font=font_16_b,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            n2h_pkg_name.grid(row=0, column=1, sticky="ew")

            n2h_pkg_status = Label(
                n2h_pkg_info_container,
                text="",
                font=font_8,
                justify="left",
                background=frame_color,
                foreground=main_font,
                anchor="w",
            )
            n2h_pkg_status.grid(row=1, column=1, sticky="ew")
            n2h_pkg_status.bind("<Button-1>", callback)

            n2h_pkg_img_frame = LabelFrame(
                n2h_info_container,
                text="Screenshot",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            n2h_pkg_img_frame.pack(anchor="n", fill=BOTH, expand=True, pady=20)

            n2h_panel = Label(n2h_pkg_img_frame, bg=frame_color)
            n2h_panel.pack(fill="both", expand="yes")

            n2h_pkg_info_frame = LabelFrame(
                n2h_info_container,
                text="Details",
                font=font_16,
                foreground=label_frame_color,
                borderwidth=0,
                highlightthickness=0,
                relief=GROOVE,
                pady=20,
                padx=20,
                background=frame_color,
            )
            n2h_pkg_info_frame.pack(anchor="n", fill=BOTH, expand=True)

            n2h_description_text = Text(
                n2h_pkg_info_frame,
                borderwidth=0,
                highlightthickness=0,
                background=frame_color,
                foreground=main_font,
                font=("Sans", 9),
            )
            n2h_description_text.pack(side=LEFT, fill=BOTH, expand=True)

            n2h_description_scrollbar = ttk.Scrollbar(
                n2h_pkg_info_frame, orient=VERTICAL, command=n2h_description_text.yview
            )
            n2h_description_text.configure(yscrollcommand=n2h_description_scrollbar.set)
            n2h_description_scrollbar.pack(side=LEFT, fill=Y)

            # Listbox

            n2h_search_button = Button(
                n2h_search_container,
                text="Select",
                command=n2h_search_command,
                background=ext_btn,
                borderwidth=0,
                highlightthickness=0,
                foreground="white",
                font=font_10,
            )
            n2h_search_button.pack(fill="x", pady=5)

            n2h_search_lframe = Frame(n2h_search_container)
            n2h_search_lframe.pack(fill="y", expand=True)

            n2h_search_scrollbar = ttk.Scrollbar(n2h_search_lframe, orient=VERTICAL)
            n2h_search_scrollbar.pack(side=RIGHT, fill="y")

            n2h_search_listbox = Listbox(
                n2h_search_lframe,
                yscrollcommand=n2h_search_scrollbar.set,
                width=40,
                borderwidth=0,
                highlightthickness=0,
            )
            n2h_search_scrollbar.config(command=n2h_search_listbox.yview)
            n2h_search_listbox.pack(fill="both", expand=True)

            for i in n2h_search_list:
                n2h_search_listbox.insert(END, i)

            n2h_info_throber_frame = Frame(n2h_main_container, background=maincolor)
            n2h_info_throber_frame.pack(fill=BOTH, expand=True, pady=20, padx=10)

            n2h_anim = ImageLabel(
                n2h_info_throber_frame,
                highlightthickness=0,
                borderwidth=0,
                background=maincolor,
            )
            n2h_anim.pack(fill=BOTH, expand=True)
            # n2h_anim.load(f"{Application_path}/images/icons/loader_search.gif")

            if "dark" in get_theme().lower():
                n2h_anim.load(f"{Application_path}/images/icons/loader_search.gif")

            else:
                n2h_anim.load(
                    f"{Application_path}/images/icons/loader_search_light.gif"
                )

        put_n2h_software()


class Custom_Installer(tk.Toplevel):
    """child window that makes the the install process graphicle"""

    def __init__(self, parent):
        super().__init__(parent)
        self["background"] = maincolor
        self.title(f"{pigro_skript_name}")
        self.icon = tk.PhotoImage(file=f"{Application_path}/images/icons/logo.png")
        self.tk.call("wm", "iconphoto", self._w, self.icon)
        self.resizable(0, 0)
        cust_app_width = 700
        cust_app_height = 500
        screen_width = self.winfo_screenwidth()
        screen_height = self.winfo_screenheight()
        x = (screen_width / 2) - (cust_app_width / 2)
        y = (screen_height / 2) - (cust_app_height / 2)
        self.geometry(f"{cust_app_width}x{cust_app_height}+{int(x)}+{int(y)}")
        self.ok_done = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/ok_128x128.png"
        )
        # progressbar
        global inst_show
        inst_show = Label(
            self,
            text="",
            bg=maincolor,
            foreground=main_font,
        )
        inst_show.pack(pady=20)

        anim = ImageLabel(self, highlightthickness=0, borderwidth=0)
        anim.pack()
        anim.load(f"{Application_path}/images/icons/loading.gif")

        if "dark" in get_theme().lower():
            anim.load(f"{Application_path}/images/icons/loading.gif")

        else:
            anim.load(f"{Application_path}/images/icons/loading_light.gif")

        self.cust_inst_termf = Frame(
            self, height=300, width=600, highlightthickness=0, borderwidth=0
        )

        self.cust_inst_wid = self.cust_inst_termf.winfo_id()

        self.cust_inst_termf["background"] = maincolor
        self.cust_inst_termf.pack(padx=45, pady=20)

        def install_parameter():
            os.system(
                f'xterm -into %d -bg Grey11 -geometry 600x300+0+0 -e "{pigro_skript}; exec bash"'
                % self.cust_inst_wid
            )

            # List all packages from apt list --installed
            cache = apt.Cache()
            global apt_installed_content
            apt_installed_content = []

            for package in cache:
                if package.is_installed:
                    apt_installed_content.append(package.name)

            # stop_it()
            anim.forget()
            close_btn.configure(state=NORMAL)
            self.title(f"Done!")
            inst_show.configure(text=" ")
            cancel_btn.place_forget()
            self.geometry(f"700x200+{int(x)}+{int(y)}")
            self.ok_done_label = Label(self, image=self.ok_done, bg=maincolor)
            self.ok_done_label.place(x=286, y=20)
            close_btn.place(x=580, y=150, width=70, height=25)

        # place the progressbar

        def close_btn_command():
            Custom_Installer.destroy(self)

        close_btn = tk.Button(self)
        ft = tkFont.Font(family="Sans", size=12)
        close_btn["font"] = ft
        close_btn["justify"] = "center"
        close_btn["highlightthickness"] = 1
        close_btn["borderwidth"] = 0
        close_btn["background"] = ext_btn
        close_btn["foreground"] = main_font
        close_btn["text"] = "Close"
        close_btn.place(x=580, y=450, width=70, height=25)
        close_btn["command"] = close_btn_command
        close_btn.configure(state=DISABLED)

        cancel_btn = tk.Button(self)
        cancel_btn["font"] = font_12
        cancel_btn["justify"] = "center"
        cancel_btn["highlightthickness"] = 1
        cancel_btn["borderwidth"] = 0
        cancel_btn["background"] = ext_btn
        cancel_btn["foreground"] = main_font
        cancel_btn["text"] = "Cancel"
        cancel_btn.place(x=500, y=450, width=70, height=25)
        cancel_btn["command"] = close_btn_command

        Thread(target=install_parameter).start()
