import os
from os import popen
import os.path
from tkinter import *
from tkinter import ttk
import tkinter as tk
from resorcess import *
from apt_manage import *
from flatpak_alias_list import *
from tabs.pop_ups import *


class TuningTab(ttk.Frame):
    def __init__(self, master):
        super().__init__(master)
        self.grid(row=0, column=0, sticky="nsew")

        # Current OV settings

        def lines_that_contain(string, fp):
            return [line for line in fp if string in line]

        def tuning_legende():
            tu_le = Tuning_Legende(self)
            tu_le.grab_set()

        def z_ram():
            z_ram = Z_Ram_Pop(self)
            z_ram.grab_set()

        def error_mass():
            e_mass = Error_Mass(self)
            e_mass.grab_set()

        # BG + Icons
        self.rm_ov_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/PiGroOV_rm.png"
        )
        self.ov1_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/PiGroOV1.png"
        )
        self.ov2_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/PiGroOV2.png"
        )
        self.ov3_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/PiGroOV3.png"
        )
        self.ov4_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/PiGroOV4.png"
        )
        self.ov5_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/PiGroOV5.png"
        )
        self.ip03 = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/download_ico.png"
        )
        self.tu_legend_ico = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/io.otsaloma.nfoview.png"
        )
        self.zram_icon = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/48x48/device_mem.png"
        )

        # OV Notifications

        def done_msg():
            d_msg = Done_Reboot(self)
            d_msg.grab_set()

        # overclocking_default/reset

        def set_default():
            os.system(f"pkexec {Application_path}/scripts/rm_ov.sh && exit")
            done_msg()
            tu_btn1.config(state=NORMAL)
            tu_btn2.config(state=NORMAL)
            tu_btn3.config(state=NORMAL)
            tu_btn4.config(state=NORMAL)

            # pigro_t_display.config(text="not nonfigured", foreground="green")
            arm_f_display.config(text="not configured")
            gpu_f_display.config(text="not configured")
            gpu_m_display.config(text="not configured")
            over_v_display.config(text="not configured")
            force_t_display.config(text="not configured")

        # overclocking_2000

        def ov_2000():
            os.system(
                f"""pkexec sh -c 'echo "#Pigro_Overclocking1\narm_freq=2000\ngpu_freq=750\nover_voltage=6\ndisable_splash=1\nforce_turbo=1" >> {config_path}'"""
            )

            done_msg()
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        # overclocking_2147

        def ov_2147():
            os.system(
                f"""pkexec sh -c 'echo "#Pigro_Overclocking2\narm_freq=2147\ngpu_freq=750\nover_voltage=8\ndisable_splash=1\nforce_turbo=1" >> {config_path}'"""
            )

            done_msg()
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        # overclocking_2200

        def ov_2200():
            os.system(
                f"""pkexec sh -c 'echo "#Pigro_Overclocking3\narm_freq=2200\ngpu_freq=750\nover_voltage=8\ndisable_splash=1\nforce_turbo=1" >> {config_path}'"""
            )

            done_msg()

            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        # overclocking_2300
        def ov_2300():
            os.system(
                f"""pkexec sh -c 'echo "#Pigro_Overclocking4\narm_freq=2300\ngpu_freq=750\nover_voltage=14\ndisable_splash=1\nforce_turbo=1" >> {config_path}'"""
            )

            done_msg()
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        # OV_Button_Frame
        self.ov_buttons = LabelFrame(
            self,
            text="Pi4 Tuning Presets",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            highlightthickness=0,
            relief=GROOVE,
            pady=20,
        )
        self.ov_buttons.pack(side=LEFT, pady=20, padx=20, fill=BOTH)
        self.ov_buttons["background"] = frame_color

        # Tuning_Button_Frame

        self.tu_reset = Button(
            self.ov_buttons,
            justify="left",
            image=self.rm_ov_icon,
            text="Default Settings",
            font=font_10,
            anchor="w",
            command=set_default,
            highlightthickness=1,
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            compound=LEFT,
            width=250,
        )
        self.tu_reset.grid(column=0, row=2, pady=10)

        global tu_btn1
        tu_btn1 = Button(
            self.ov_buttons,
            justify="left",
            image=self.ov1_icon,
            text="Crank It Up",
            font=font_10,
            anchor="w",
            command=ov_2000,
            highlightthickness=1,
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            compound=LEFT,
            width=250,
        )
        tu_btn1.grid(column=0, row=4, pady=10)

        global tu_btn2
        tu_btn2 = Button(
            self.ov_buttons,
            justify="left",
            image=self.ov2_icon,
            text="You Sir... Need A Fan!",
            font=font_10,
            anchor="w",
            command=ov_2147,
            highlightthickness=1,
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            compound=LEFT,
            width=250,
        )
        tu_btn2.grid(column=0, row=6, pady=10)

        global tu_btn3
        tu_btn3 = Button(
            self.ov_buttons,
            justify="left",
            image=self.ov3_icon,
            text="Take It To The Max!",
            font=font_10,
            anchor="w",
            command=ov_2200,
            highlightthickness=1,
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            compound=LEFT,
            width=250,
        )
        tu_btn3.grid(column=0, row=8, pady=10)

        global tu_btn4
        tu_btn4 = Button(
            self.ov_buttons,
            justify="left",
            image=self.ov4_icon,
            text="Honey,\nthe fuse blew again!",
            font=font_10,
            anchor="w",
            command=ov_2300,
            highlightthickness=1,
            borderwidth=0,
            background=ext_btn,
            foreground="white",
            compound=LEFT,
            width=250,
        )
        tu_btn4.grid(column=0, row=9, pady=10)

        self.tu_legende = Button(
            self.ov_buttons,
            justify="left",
            text="Preset Info",
            font=font_10,
            highlightthickness=1,
            borderwidth=0,
            background="#f04a50",
            foreground="white",
            anchor="w",
            command=tuning_legende,
            image=self.tu_legend_ico,
            compound=LEFT,
            width=250,
        ).grid(column=0, row=13, pady=10)

        # Overclocking State Main Frame
        self.ov_state_display_frame = Frame(
            self,
            borderwidth=0,
            highlightthickness=0,
            highlightcolor="white",
            relief=GROOVE,
        )
        self.ov_state_display_frame.pack(
            anchor="n", padx=10, pady=20, fill=BOTH, expand=True
        )
        self.ov_state_display_frame["background"] = maincolor

        with open("/proc/device-tree/model", "r") as model_file:
            # Read and print the model information
            global pi_model
            pi_model = model_file.read().strip()

        if "Raspberry Pi 5" in pi_model:
            self.tu_reset.config(state=DISABLED)
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        # Custom Settings
        self.custom_settings = LabelFrame(
            self.ov_state_display_frame,
            text="Custom Settings",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            highlightthickness=0,
            highlightcolor="white",
            relief=GROOVE,
            pady=20,
            padx=10,
        )
        self.custom_settings.pack(anchor="n", padx=10, fill="x")
        self.custom_settings["background"] = frame_color

        def set_arm_freq():
            print("Setting arm_freq to:", arm_freq_spinbox.get())
            os.system(
                f"""pkexec sh -c 'echo "arm_freq={arm_freq_spinbox.get()}" >> {config_path}'"""
            )
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        def reset_arm_freq():
            print("Resetting arm_freq to:", arm_freq_spinbox.get())
            os.system(f"pkexec sed -i '/arm_freq/d' {config_path}")

        def set_gpu_freq():
            print("Setting gpu_freq to:", gpu_freq_spinbox.get())
            os.system(
                f"""pkexec sh -c 'echo "gpu_freq={gpu_freq_spinbox.get()}" >> {config_path}'"""
            )
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        def reset_gpu_freq():
            print("Resetting gpu_freq to:", gpu_freq_spinbox.get())
            os.system(f"pkexec sed -i '/gpu_freq/d' {config_path}")

        def set_gpu_mem():
            print("Setting gpu_mem to:", gpu_mem_spinbox.get())
            os.system(
                f"""pkexec sh -c 'echo "gpu_mem={gpu_mem_spinbox.get()}" >> {config_path}'"""
            )
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        def reset_gpu_mem():
            print("Resetting gpu_mem to:", gpu_mem_spinbox.get())
            os.system(f"pkexec sed -i '/gpu_mem/d' {config_path}")

        def set_over_voltage():
            print("Setting over_voltage to:", over_voltage_spinbox.get())
            os.system(
                f"""pkexec sh -c 'echo "over_voltage={over_voltage_spinbox.get()}" >> {config_path}'"""
            )
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        def reset_over_voltage():
            print("Resetting over_voltage to:", over_voltage_spinbox.get())
            os.system(f"pkexec sed -i '/over_voltage/d' {config_path}")

        def set_over_voltage_delta():
            print("Setting over_voltage to:", over_voltage_delta_spinbox.get())
            os.system(
                f"""pkexec sh -c 'echo "over_voltage_delta={over_voltage_delta_spinbox.get()}" >> {config_path}'"""
            )

        def reset_over_voltage_delta():
            print("Resetting over_voltage to:", over_voltage_delta_spinbox.get())
            os.system(f"pkexec sed -i '/over_voltage_delta/d' {config_path}")

        def set_force_turbo():
            os.system(f"""pkexec sh -c 'echo "force_turbo=1" >> {config_path}'""")
            tu_btn1.config(state=DISABLED)
            tu_btn2.config(state=DISABLED)
            tu_btn3.config(state=DISABLED)
            tu_btn4.config(state=DISABLED)

        def reset_force_turbo():
            os.system(f"pkexec sed -i '/force_turbo/d' {config_path}")
            force_t_display.config(text="State: Default")

        def lines_that_contain(string, fp):
            return [line for line in fp if string in line]

        def reboot_n():
            popen(f"pkexec reboot")

        # Expert Frame
        x_mode_frame = Frame(self.custom_settings, bg=frame_color)
        x_mode_frame.pack(fill="x", expand=True)

        arm_freq_label = tk.Label(
            x_mode_frame,
            text="arm_freq ",
            justify="right",
            anchor="w",
            background=frame_color,
            foreground=main_font,
        )
        arm_freq_label.grid(row=0, column=0, sticky="ew")

        arm_freq_spinbox = ttk.Spinbox(x_mode_frame, from_=1500, to=2300, increment=1)
        arm_freq_spinbox.grid(row=0, column=1, sticky="ew")

        arm_freq_set_button = tk.Button(
            x_mode_frame,
            text="Set",
            command=set_arm_freq,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        arm_freq_set_button.grid(row=0, column=2, padx=10, pady=5, sticky="ew")

        arm_freq_reset_button = tk.Button(
            x_mode_frame,
            text="Reset",
            command=reset_arm_freq,
            foreground="white",
            background="#f04a50",
            highlightthickness=1,
            borderwidth=0,
        )
        arm_freq_reset_button.grid(row=0, column=3, sticky="ew")

        global arm_f_display
        arm_f_display = Label(
            x_mode_frame,
            anchor="w",
            justify=LEFT,
            text="State: Default",
            highlightthickness=0,
            borderwidth=2,
            background=frame_color,
            foreground=main_font,
            font=font_10,
            width=25,
        )
        arm_f_display.grid(column=4, row=0)

        gpu_freq_label = tk.Label(
            x_mode_frame,
            text="gpu_freq ",
            justify="right",
            compound="left",
            anchor="w",
            background=frame_color,
            foreground=main_font,
        )
        gpu_freq_label.grid(row=1, column=0, sticky="ew")

        gpu_freq_spinbox = ttk.Spinbox(x_mode_frame, from_=500, to=900, increment=1)
        gpu_freq_spinbox.grid(row=1, column=1, sticky="ew")

        gpu_freq_set_button = tk.Button(
            x_mode_frame,
            text="Set",
            command=set_gpu_freq,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        gpu_freq_set_button.grid(row=1, column=2, padx=10, pady=5, sticky="ew")

        gpu_freq_reset_button = tk.Button(
            x_mode_frame,
            text="Reset",
            command=reset_gpu_freq,
            foreground="white",
            background="#f04a50",
            highlightthickness=1,
            borderwidth=0,
        )
        gpu_freq_reset_button.grid(row=1, column=3, sticky="ew")

        global gpu_f_display
        gpu_f_display = Label(
            x_mode_frame,
            anchor="w",
            justify=LEFT,
            text="State: Default",
            highlightthickness=0,
            borderwidth=2,
            background=frame_color,
            foreground=main_font,
            font=font_10,
            width=25,
        )
        gpu_f_display.grid(column=4, row=1)

        gpu_mem_label = tk.Label(
            x_mode_frame,
            text="gpu_mem ",
            justify="right",
            compound="left",
            anchor="w",
            background=frame_color,
            foreground=main_font,
        )
        gpu_mem_label.grid(row=2, column=0, sticky="ew")

        gpu_mem_spinbox = ttk.Spinbox(x_mode_frame, from_=16, to=256, increment=1)
        gpu_mem_spinbox.grid(row=2, column=1, sticky="ew")

        gpu_mem_set_button = tk.Button(
            x_mode_frame,
            text="Set",
            command=set_gpu_mem,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        gpu_mem_set_button.grid(row=2, column=2, padx=10, pady=5, sticky="ew")

        gpu_mem_reset_button = tk.Button(
            x_mode_frame,
            text="Reset",
            command=reset_gpu_mem,
            foreground="white",
            background="#f04a50",
            highlightthickness=1,
            borderwidth=0,
        )
        gpu_mem_reset_button.grid(row=2, column=3, sticky="ew")

        global gpu_m_display
        gpu_m_display = Label(
            x_mode_frame,
            anchor="w",
            justify=LEFT,
            text="State: Default",
            highlightthickness=0,
            borderwidth=2,
            background=frame_color,
            foreground=main_font,
            font=font_10,
            width=25,
        )
        gpu_m_display.grid(column=4, row=2)

        over_voltage_label = tk.Label(
            x_mode_frame,
            text="over_voltage ",
            justify="right",
            compound="left",
            anchor="w",
            background=frame_color,
            foreground=main_font,
        )
        over_voltage_label.grid(row=3, column=0, sticky="ew")

        over_voltage_spinbox = ttk.Spinbox(x_mode_frame, from_=1, to=14, increment=1)
        over_voltage_spinbox.grid(row=3, column=1, sticky="ew")

        over_voltage_set_button = tk.Button(
            x_mode_frame,
            text="Set",
            command=set_over_voltage,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        over_voltage_set_button.grid(row=3, column=2, padx=10, pady=5, sticky="ew")

        over_voltage_reset_button = tk.Button(
            x_mode_frame,
            text="Reset",
            command=reset_over_voltage,
            foreground="white",
            background="#f04a50",
            highlightthickness=1,
            borderwidth=0,
        )
        over_voltage_reset_button.grid(row=3, column=3, sticky="ew")

        global over_v_display
        over_v_display = Label(
            x_mode_frame,
            anchor="w",
            justify=LEFT,
            text="State: Default",
            highlightthickness=0,
            borderwidth=2,
            background=frame_color,
            foreground=main_font,
            font=font_10,
            width=25,
        )
        over_v_display.grid(column=4, row=3)

        over_voltage_delta_delta_label = tk.Label(
            x_mode_frame,
            text="over_voltage_delta ",
            justify="right",
            compound="left",
            anchor="w",
            background=frame_color,
            foreground=main_font,
        )
        over_voltage_delta_delta_label.grid(row=4, column=0, sticky="ew")

        over_voltage_delta_spinbox = ttk.Spinbox(
            x_mode_frame, from_=1, to=14, increment=1
        )
        over_voltage_delta_spinbox.grid(row=4, column=1, sticky="ew")

        over_voltage_delta_set_button = tk.Button(
            x_mode_frame,
            text="Set",
            command=set_over_voltage_delta,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        over_voltage_delta_set_button.grid(
            row=4, column=2, padx=10, pady=5, sticky="ew"
        )

        over_voltage_delta_reset_button = tk.Button(
            x_mode_frame,
            text="Reset",
            command=reset_over_voltage_delta,
            foreground="white",
            background="#f04a50",
            highlightthickness=1,
            borderwidth=0,
        )
        over_voltage_delta_reset_button.grid(row=4, column=3, sticky="ew")

        global over_v_d_display
        over_v_d_display = Label(
            x_mode_frame,
            anchor="w",
            justify=LEFT,
            text="State: Default",
            highlightthickness=0,
            borderwidth=2,
            background=frame_color,
            foreground=main_font,
            font=font_10,
            width=25,
        )
        over_v_d_display.grid(column=4, row=4)

        force_turbo_label = tk.Label(
            x_mode_frame,
            text="force_turbo ",
            justify="right",
            compound="left",
            anchor="w",
            background=frame_color,
            foreground=main_font,
        )
        force_turbo_label.grid(row=5, column=0, sticky="ew")

        force_turbo_set_button = tk.Button(
            x_mode_frame,
            text="Set",
            command=set_force_turbo,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        force_turbo_set_button.grid(row=5, column=2, padx=10, pady=5, sticky="ew")

        force_turbo_label = tk.Label(
            x_mode_frame,
            text="",
            width=25,
            background=frame_color,
            foreground=main_font,
        )
        force_turbo_label.grid(row=5, column=1, sticky="ew")

        force_turbo_reset_button = tk.Button(
            x_mode_frame,
            text="Reset",
            command=reset_force_turbo,
            foreground="white",
            background="#f04a50",
            highlightthickness=1,
            borderwidth=0,
        )
        force_turbo_reset_button.grid(row=5, column=3, sticky="ew")

        global force_t_display
        force_t_display = Label(
            x_mode_frame,
            anchor="w",
            justify=LEFT,
            text="State: Default",
            highlightthickness=0,
            borderwidth=2,
            background=frame_color,
            foreground=main_font,
            font=font_10,
            width=25,
        )
        force_t_display.grid(row=5, column=4, sticky="ew", padx=5)

        reboot_button = tk.Button(
            x_mode_frame,
            text="Reboot System",
            command=reboot_n,
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        reboot_button.grid(row=6, column=0, columnspan=4, sticky="ew", pady=5)

        def swap_or_zram():
            if "Ubuntu" in nice_name:
                self.swap_frame = LabelFrame(
                    self.ov_state_display_frame,
                    text="Swap Resizer",
                    font=font_16,
                    foreground=label_frame_color,
                    borderwidth=0,
                    highlightthickness=0,
                    highlightcolor="white",
                    relief=FLAT,
                    background=maincolor,
                    pady=20,
                )
                self.swap_frame.pack(anchor="w", padx=10, fill="x")

                def on_button_click():
                    selected_value = self.combo.get()
                    ubuntu_swap_cmd = f"sudo swapoff -a && sudo dd if=/dev/zero of=/swapfile bs=1G count={selected_value} && sudo chmod 0600 /swapfile && sudo mkswap /swapfile && sudo swapon /swapfile"

                    print(f"Selected value: {selected_value}")
                    os.system(
                        f"x-terminal-emulator -e 'bash -c \"{ubuntu_swap_cmd}; exec bash\"'"
                    )
                    done_msg()

                # Create a Combobox with values from 1 to 16
                self.combo_values = [str(i) for i in range(1, 17)]
                self.combo = ttk.Combobox(self.swap_frame, values=self.combo_values)
                self.combo.set("Select Swap Size")  # Set the default value
                self.combo.grid(padx=10, pady=10, row=0, column=0, sticky="ewns")

                # Create a Button next to the Combobox
                self.button = Button(
                    self.swap_frame,
                    text="Set",
                    command=on_button_click,
                    foreground="white",
                    background=ext_btn,
                    highlightthickness=1,
                    borderwidth=0,
                )
                self.button.grid(
                    padx=10, pady=10, row=0, column=2
                )  # pack(padx=10, pady=10, side=tk.LEFT)
            if "Ubuntu" or "Debian" or "Raspbian" or "Raspberry Pi OS" in nice_name:
                pass

        swap_or_zram()

        preload_text = """Preload is a Linux tool designed to improve system responsiveness by\npredicting and preloading frequently used dynamic libraries into memory,\nreducing application startup times. It analyzes the user's behavior and\noptimizes resource utilization to enhance overall system performance."""

        self.preload_frame = LabelFrame(
            self.ov_state_display_frame,
            text="Preload",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            highlightthickness=0,
            highlightcolor="white",
            background=maincolor,
            relief=FLAT,
        )
        self.preload_frame.pack(anchor="n", padx=10, fill="x", expand=True)

        self.tu_info = Label(
            self.preload_frame,
            text=preload_text,
            font=font_10,
            justify="left",
            anchor="w",
            highlightthickness=0,
            borderwidth=0,
            background=frame_color,
            foreground=main_font,
        ).pack(padx=10, fill="x", expand=True)

        # Create a Button next to the Combobox
        self.preload_button = Button(
            self.preload_frame,
            text="Install Preload",
            foreground="white",
            background=ext_btn,
            highlightthickness=1,
            borderwidth=0,
        )
        self.preload_button.pack(padx=10, pady=10, anchor="w")

        tu_info_text = """"""

        self.tu_info = Label(
            self.ov_state_display_frame,
            text=tu_info_text,
            font=font_8_b,
            highlightthickness=0,
            borderwidth=0,
            background=frame_color,
            foreground=info_color,
            justify=LEFT,
        ).pack(pady=20, padx=10, anchor="w")

        def ov_display():
            # Overclock Display Functions
            with open(f"{config_path}") as f:
                for line in f:
                    if "arm_freq=" in line:
                        # print(line)
                        arm_freq_reset_button.config(state="normal")
                        arm_freq_set_button.config(state="disabled")
                        arm_f_display.config(text=f"State: {line[9:-1]} MHz")
                        tu_btn1.config(state=DISABLED)
                        tu_btn2.config(state=DISABLED)
                        tu_btn3.config(state=DISABLED)
                        tu_btn4.config(state=DISABLED)
                        break

                else:
                    arm_freq_reset_button.config(state="disabled")
                    arm_freq_set_button.config(state="normal")
                    arm_f_display.config(text="State: Default")

            with open(f"{config_path}") as f:
                for line in f:
                    if "gpu_freq=" in line:
                        # print("enabled")
                        gpu_freq_reset_button.config(state="normal")
                        gpu_freq_set_button.config(state="disabled")
                        gpu_f_display.config(
                            text=f"State: {line[9:-1]} MHz",
                        )
                        tu_btn1.config(state=DISABLED)
                        tu_btn2.config(state=DISABLED)
                        tu_btn3.config(state=DISABLED)
                        tu_btn4.config(state=DISABLED)
                        break
                else:
                    gpu_freq_reset_button.config(state="disabled")
                    gpu_freq_set_button.config(state="normal")
                    gpu_f_display.config(text="State: Default")

            with open(f"{config_path}") as f:
                for line in f:
                    if "gpu_mem=" in line:
                        # print("enabled")
                        gpu_mem_reset_button.config(state="normal")
                        gpu_mem_set_button.config(state="disabled")
                        if "gpu_mem" in line:
                            gpu_m_display.config(
                                text=f"State: {line[8:-1]} MB",
                            )
                        break
                else:
                    gpu_mem_reset_button.config(state="disabled")
                    gpu_mem_set_button.config(state="normal")
                    gpu_m_display.config(text="State: Default")

            with open(f"{config_path}") as f:
                for line in f:
                    if "over_voltage=" in line:
                        # print("enabled")
                        over_voltage_reset_button.config(state="normal")
                        over_voltage_set_button.config(state="disabled")
                        over_v_display.config(
                            text=f"State: {line[13:-1]}",
                        )
                        tu_btn1.config(state=DISABLED)
                        tu_btn2.config(state=DISABLED)
                        tu_btn3.config(state=DISABLED)
                        tu_btn4.config(state=DISABLED)
                        break
                else:
                    over_voltage_reset_button.config(state="disabled")
                    over_voltage_set_button.config(state="normal")
                    over_v_display.config(text="State: Default")

            with open(f"{config_path}") as f:
                for line in f:
                    if "over_voltage_delta=" in line:
                        # print("enabled")
                        over_voltage_delta_reset_button.config(state="normal")
                        over_voltage_delta_set_button.config(state="disabled")
                        over_v_d_display.config(
                            text=f"State: {line[19:-1]}",
                        )
                        if "Raspberry Pi 5" in pi_model:
                            over_voltage_delta_reset_button.config(state="normal")
                            over_voltage_delta_set_button.config(state="disabled")
                        break
                else:
                    if "Raspberry Pi 4" in pi_model:
                        over_voltage_delta_reset_button.config(state="disabled")
                        over_voltage_delta_set_button.config(state="disabled")
                        over_v_d_display.config(text="Pi 5 Only")
                    else:
                        over_voltage_delta_reset_button.config(state="disabled")
                        over_voltage_delta_set_button.config(state="normal")
                        over_v_d_display.config(text="State: Default")

            with open(f"{config_path}") as f:
                for line in f:
                    if "force_turbo=" in line:
                        # print("enabled")
                        force_turbo_reset_button.config(state="normal")
                        force_turbo_set_button.config(state="disabled")
                        force_turbo_label.config(text="ENABLED")
                        force_t_display.config(
                            text=f"State: {line[12:-1]}",
                        )
                        tu_btn1.config(state=DISABLED)
                        tu_btn2.config(state=DISABLED)
                        tu_btn3.config(state=DISABLED)
                        tu_btn4.config(state=DISABLED)
                        break
                else:
                    force_turbo_reset_button.config(state="disabled")
                    force_turbo_set_button.config(state="normal")
                    force_turbo_label.config(text="DISABLED")

        def refresh_OV_stats():
            ov_display()
            self.after(1000, refresh_OV_stats)

        refresh_OV_stats()
