#!/usr/bin/python3

import os
import os.path
from tkinter import *
from tkinter import ttk
from tkinter import filedialog
from resorcess import *
from apt_manage import *
from snap_manage import *
from flatpak_alias_list import *
from flatpak_manage import *
from tool_tipps import CreateToolTip
from tabs.pop_ups import *


class UpdateTab(ttk.Frame):
    def __init__(self, master):
        super().__init__(master)
        self.grid(row=0, column=0, sticky="nsew")
        self.folder_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/folder_s.png"
        )
        self.up_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/pack_up_s.png"
        )
        self.gup_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/pack_upg_s.png"
        )
        self.recover_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/recover_s.png"
        )
        self.fup_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/pack_fupg_s.png"
        )
        self.allow_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/allow_s.png"
        )
        self.arm_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/del_s.png"
        )
        self.confa_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/confa_s.png"
        )
        self.re_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/re_s.png"
        )
        self.inst_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/debinst_s.png"
        )
        self.term_icon = PhotoImage(
            file=f"{Application_path}/images/icons/pigro_icons/terminal_s.png"
        )

        self.term_logo = PhotoImage(
            file=f"{Application_path}/images/icons/papirus/goterminal.png"
        )

        self.background = maincolor

        def up_action(text):
            """Passes commands du auto generated buttons"""
            frame_width = self.termf.winfo_width()

            frame_height = self.termf.winfo_height()
            print(
                "The width & height of the label is:",
                frame_width,
                frame_height,
                "pixels",
            )
            if text == "Update":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec apt update -y |lolcat && sleep 5 && exit ; exec bash"'
                    % wid
                )
            if text == "Update & Upgrade":
                command = (
                    f"xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "
                    "\"pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY bash -c 'apt update -y && apt upgrade -y' | lolcat && "
                    'sleep 5 && exit; exec bash"' % wid
                )
                os.popen(command)
            if text == "Fix Missing":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec apt install --fix-missing |lolcat && sleep 5 && exit; exec bash"'
                    % wid
                )
            if text == "Fix Broken":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec apt install --fix-missing |lolcat && sleep 5 && exit; exec bash"'
                    % wid
                )
            if text == "Dist Upgrade":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec apt dist-upgrade -y |lolcat && sleep 5 && exit; exec bash"'
                    % wid
                )
            if text == "Autoremove":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec apt autoremove -y |lolcat && sleep 5 && exit ; exec bash"'
                    % wid
                )
            if text == "Install Local .DEB":
                self.filename = filedialog.askopenfilename(
                    initialdir="~",
                    title="Select A File",
                    filetypes=((".deb files", "*.deb"),),
                )
                os.popen(f"gdebi-gtk {self.filename}")

            if text == "dpkg --configure -a":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec dpkg --configure -a |lolcat && sleep 5 && exit; exec bash"'
                    % wid
                )
            if text == "Allow Sources":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "{Application_path}/scripts/addunsignedrepo.sh && exit; exec bash"'
                    % wid
                )
            if text == "Show Upgradable":
                os.popen(
                    f"xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "
                    "\"pkexec apt list --upgradable |lolcat && read -p 'Press Enter to exit.' && exit; exec bash\""
                    % wid
                )

        self.update_btn_frame = Frame(
            self,
            borderwidth=0,
            relief=GROOVE,
            highlightthickness=0,
        )
        self.update_btn_frame.pack(padx=28, pady=10, anchor="n", fill="x", side="left")
        self.update_btn_frame["background"] = frame_color

        self.termf = Frame(
            self,
            highlightthickness=0,
            borderwidth=0,
        )

        self.term_logo_label = Label(
            self.termf, image=self.term_logo, background=frame_color
        )
        self.term_logo_label.pack(fill=BOTH, expand=True)

        self.termf.pack(fill=BOTH, expand=True, pady=50, padx=30)

        global wid
        wid = self.termf.winfo_id()
        self.termf["background"] = frame_color

        self.btn_frame = LabelFrame(
            self.update_btn_frame,
            text="APT Options",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            relief=GROOVE,
            highlightthickness=0,
            background=frame_color,
            pady=10,
        )
        self.btn_frame.pack(anchor="n")

        # Button list
        up_button_list = [
            "Update",
            "Update & Upgrade",
            "Show Upgradable",
            "Full Upgrade",
            "Fix Missing",
            "Fix Broken",
            "Autoremove",
            "dpkg --configure -a",
            "Install Local .DEB",
            "Allow Sources",
        ]

        up_button_list1 = []
        conf_row = 0
        conf_column = 0
        for up_button in up_button_list:
            # Generates buttons from list with grid
            self.up_button_x = Button(
                self.btn_frame,
                justify="left",
                compound="left",
                anchor="w",
                text=up_button,
                command=lambda text=up_button: up_action(text),
                borderwidth=0,
                background=ext_btn,
                foreground="white",
            )
            self.up_button_x.grid(
                row=conf_row, column=conf_column, padx=5, pady=5, sticky="ew"
            )
            up_button_list1.append(self.up_button_x)
            conf_column = conf_column + 1
            if conf_column == 1:
                conf_row = conf_row + 1
                conf_column = 0
            if up_button == "Update":
                self.up_button_x.config(image=self.up_icon)
                up_button_x_ttp = CreateToolTip(
                    self.up_button_x, "sudo apt update -y |lolcat"
                )
            if up_button == "Show Upgradable":
                self.up_button_x.config(image=self.up_icon)
            if up_button == "Fix Missing":
                self.up_button_x.config(image=self.up_icon)
            if up_button == "Fix Broken":
                self.up_button_x.config(image=self.up_icon)
            if up_button == "Update & Upgrade":
                self.up_button_x.config(image=self.gup_icon)
                up_button_x_ttp = CreateToolTip(
                    self.up_button_x,
                    "sudo apt update -y |lolcat && sudo apt upgrade -y|lolcat",
                )

            if up_button == "Full Upgrade":
                self.up_button_x.config(image=self.fup_icon)
                up_button_x_ttp = CreateToolTip(
                    self.up_button_x,
                    "sudo apt update -y && sudo apt full-upgrade -y && sudo apt dist-upgrade -y |lolcat",
                )

            if up_button == "Autoremove":
                self.up_button_x.config(image=self.arm_icon)
                up_button_x_ttp = CreateToolTip(
                    self.up_button_x, "pkexec apt autoremove|lolcat"
                )
            if up_button == "Install Local .DEB":
                self.up_button_x.config(image=self.inst_icon)
                up_button_x_ttp = CreateToolTip(self.up_button_x, "Install a .DEB file")
            if up_button == "dpkg --configure -a":
                self.up_button_x.config(image=self.confa_icon)
                up_button_x_ttp = CreateToolTip(
                    self.up_button_x,
                    "--configure package...|-a|--pending\nReconfigure an unpacked package. If -a  or  --pending  is  given\ninstead  of  package, all unpacked but unconfigured packages are\nconfigured.",
                )
            if up_button == "Open Sources.list.d":
                self.up_button_x.config(image=self.folder_icon)
            if up_button == "Allow Sources":
                self.up_button_x.config(image=self.gup_icon)

        def nala_action(text):
            """Passes commands du auto generated buttons"""
            frame_width = self.termf.winfo_width()

            frame_height = self.termf.winfo_height()
            print(
                "The width & height of the label is:",
                frame_width,
                frame_height,
                "pixels",
            )
            if text == "Fetch":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec nala fetch && sleep 5 && exit ; exec bash"'
                    % wid
                )
            if text == "Update":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec nala update && sleep 5 && exit ; exec bash"'
                    % wid
                )

            if text == "Update & Upgrade":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec nala upgrade && sleep 5 && exit ; exec bash"'
                    % wid
                )

        self.nala_frame = LabelFrame(
            self.update_btn_frame,
            text="Nala Options",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            relief=GROOVE,
            highlightthickness=0,
            background=frame_color,
            pady=10,
        )
        self.nala_frame.pack(anchor="n", fill="x")

        self.nala_frame.columnconfigure(0, weight=1)
        self.nala_frame.rowconfigure(0, weight=1)

        nala_button_list = [
            "Update",
            "Update & Upgrade",
            "Fetch",
        ]

        nala_button_list1 = []
        conf_row = 0
        conf_column = 0
        for nala_button in nala_button_list:
            # Generates buttons from list with grid
            self.nala_button_x = Button(
                self.nala_frame,
                justify="left",
                compound="left",
                anchor="w",
                text=nala_button,
                command=lambda text=nala_button: nala_action(text),
                borderwidth=0,
                background=ext_btn,
                foreground="white",
                state=DISABLED,
            )
            self.nala_button_x.grid(
                row=conf_row, column=conf_column, padx=5, pady=5, sticky="ew"
            )
            nala_button_list1.append(self.nala_button_x)
            conf_column = conf_column + 1
            if conf_column == 1:
                conf_row = conf_row + 1
                conf_column = 0
            if nala_button == "Update":
                self.nala_button_x.config(image=self.up_icon, state=DISABLED)
                if nala_path == True:
                    self.nala_button_x.config(state=NORMAL)

            if nala_button == "Fetch":
                self.nala_button_x.config(image=self.up_icon, state=DISABLED)
                if nala_path == True:
                    self.nala_button_x.config(state=NORMAL)

            if nala_button == "Update & Upgrade":
                self.nala_button_x.config(image=self.up_icon, state=DISABLED)
                if nala_path == True:
                    self.nala_button_x.config(state=NORMAL)

        def flatpak_action(text):
            """Passes commands du auto generated buttons"""
            frame_width = self.termf.winfo_width()

            frame_height = self.termf.winfo_height()
            print(
                "The width & height of the label is:",
                frame_width,
                frame_height,
                "pixels",
            )
            if text == "Update":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "flatpak update -y && sleep 5 && exit ; exec bash"'
                    % wid
                )
            if text == "Tidy Up Unuesed":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "flatpak uninstall --unused -y && sleep 5 && exit; exec bash"'
                    % wid
                )

        self.flatpak_frame = LabelFrame(
            self.update_btn_frame,
            text="Flatpak Options",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            relief=GROOVE,
            highlightthickness=0,
            background=frame_color,
            pady=10,
        )
        self.flatpak_frame.pack(anchor="n", fill="x")

        self.flatpak_frame.columnconfigure(0, weight=1)
        self.flatpak_frame.rowconfigure(0, weight=1)

        flatpak_button_list = [
            "Update",
            "Tidy Up Unuesed",
        ]

        flatpak_button_list1 = []
        conf_row = 0
        conf_column = 0
        for flatpak_button in flatpak_button_list:
            # Generates buttons from list with grid
            self.flatpak_button_x = Button(
                self.flatpak_frame,
                justify="left",
                compound="left",
                anchor="w",
                text=flatpak_button,
                command=lambda text=flatpak_button: flatpak_action(text),
                borderwidth=0,
                background=ext_btn,
                foreground="white",
            )
            self.flatpak_button_x.grid(
                row=conf_row, column=conf_column, padx=5, pady=5, sticky="ew"
            )
            flatpak_button_list1.append(self.flatpak_button_x)
            conf_column = conf_column + 1
            if conf_column == 1:
                conf_row = conf_row + 1
                conf_column = 0
            if flatpak_button == "Update":
                self.flatpak_button_x.config(image=self.up_icon)
                if flatpak_path == False:
                    self.flatpak_button_x.config(state=DISABLED)

            if flatpak_button == "Tidy Up Unuesed":
                self.flatpak_button_x.config(image=self.up_icon)
                if flatpak_path == False:
                    self.flatpak_button_x.config(state=DISABLED)

        def snap_action(text):
            """Passes commands du auto generated buttons"""
            frame_width = self.termf.winfo_width()

            frame_height = self.termf.winfo_height()
            print(
                "The width & height of the label is:",
                frame_width,
                frame_height,
                "pixels",
            )
            if text == "Update":
                os.popen(
                    f'xterm -into %d -bg Grey11 -geometry {frame_height}x{frame_width} -e "pkexec snap refresh && sleep 5 && exit ; exec bash"'
                    % wid
                )

        self.snap_frame = LabelFrame(
            self.update_btn_frame,
            text="Snap Options",
            font=font_16,
            foreground=label_frame_color,
            borderwidth=0,
            relief=GROOVE,
            highlightthickness=0,
            background=frame_color,
            pady=10,
        )
        self.snap_frame.pack(anchor="n", fill="x", expand=True)

        self.snap_frame.columnconfigure(0, weight=1)
        self.snap_frame.rowconfigure(0, weight=1)

        snap_button_list = [
            "Update",
        ]

        snap_button_list1 = []
        conf_row = 0
        conf_column = 0
        for snap_button in snap_button_list:
            # Generates buttons from list with grid
            self.snap_button_x = Button(
                self.snap_frame,
                justify="left",
                compound="left",
                anchor="w",
                text=snap_button,
                command=lambda text=snap_button: snap_action(text),
                borderwidth=0,
                background=ext_btn,
                foreground="white",
            )
            self.snap_button_x.grid(
                row=conf_row, column=conf_column, padx=5, pady=5, sticky="ew"
            )
            snap_button_list1.append(self.snap_button_x)
            conf_column = conf_column + 1
            if conf_column == 1:
                conf_row = conf_row + 1
                conf_column = 0
            if snap_button == "Update":
                self.snap_button_x.config(image=self.up_icon)
                if is_snap_installed() == False:
                    self.snap_button_x.config(state=DISABLED)
